RECOUNT_CONFIG_IS_SHOWN=nil;
IS_BARS_LOADED={};
IS_RECOUNT_SKINNED = nil;
MERGED_TEXTURES_CREATED=0

rs_saved={};

_G["RecountSkin"] = {}
local me=RecountSkin
local FORCE=1

--ACE comes with recount, no need to stress cus we are dependant :-)
--to get localized string for the MainWindowDataModes
  local AceLocale = LibStub("AceLocale-3.0")
  local L = AceLocale:GetLocale("Recount")
--Also installed with Recount
  local SM = LibStub:GetLibrary("LibSharedMedia-3.0")

function me:Combatants() local i=0 for k,v in pairs(Recount.db2.combatants) do i=i+1 end return i end

me.Windows={}
me.chat_Signature="SkinByNth: "
me.texPath="Interface\\AddOns\\RecountSkinByNth\\textures\\"
--REMEMBER THIS
  me.MadeForVersion=1386  --The Recount Version we are stable on.
--REMEMBER THIS
me.loader=CreateFrame("Frame", nil, nil)
me.loader:RegisterEvent("VARIABLES_LOADED")
me.loader:RegisterEvent("PLAYER_REGEN_ENABLED")
me.loader.elapsed=0; me.loader.update=0.25
me.loader:SetScript("OnUpdate", function(self,elapsed) self.elapsed=self.elapsed + elapsed; if self.update>self.elapsed then return else self.elapsed=0 end  
	local update
	--if RECOUNT_CONFIG_IS_SHOWN or not me.DoOnceDone then update=1  end
	if RECOUNT_CONFIG_IS_SHOWN then update=1  end
	if Recount.FightName~=me.lastFightName then update=1 end	--On FightMode Change
	  me.lastFightName=Recount.FightName;
	if me:Combatants()==0 and me.lastSize~=0 then update=1; me.FightsPopup:Hide() end	--On Reset
	  me.lastSize=me:Combatants();
	if update then me:UpdateRecountConfigRelated() end
  end)--SetScript
me.loader:SetScript("OnEvent",function(self,event)
  if event=="VARIABLES_LOADED" then end
  if event=="PLAYER_REGEN_ENABLED" then me.FightsPopup:Hide() return end
  if not rs_saved["Mode"] then rs_saved["Mode"] = {} end
  if not rs_saved["Shown"] then rs_saved["Shown"] = {} end
  if not rs_saved["Anchor"] then rs_saved["Anchor"] = {} end
  if not rs_saved["WindowSize"] then rs_saved["WindowSize"] = {} end

  if IsAddOnLoaded("Recount") and not(IS_RECOUNT_SKINNED) then
    --if me.MadeForVersion~=Recount.Version then print(me.chat_Signature.."Version missmatch, may still be fine...") end
	  me:CreateConfigWindow()
	  me:UpdateRecountConfigRelated()
      me:CreateTooltip()
      me:CreateSelectModeWindow()
      me:CreateFightsPopup()
      me:CreateReportWindow()
      me:CreateDetailsTooltip()
      me:RecountSkinByNth()				--Modify Recounts appearence
      me:CreateWindow()					--Create the SecondaryWindows.. /rs new; opens or creates subsequent windows
	  
	  if #rs_saved["Shown"]>1 then
	    local lastVisible=0
		for i=2,#rs_saved["Shown"] do if rs_saved["Shown"][i] then lastVisible=i end end--do
		if lastVisible>1 then
	      for i=2,lastVisible do me:CreateWindow() end--do
		end--if
	  end
	  me:UpdateRecountConfigRelated()
  end
		
  if rs_saved["DisableAutoHideReport"] then me.ReportWindow.CheckButton:SetChecked(true); me.ReportWindow.ExitButton:Show() end
  if not rs_saved["TextureTable"] then rs_saved["TextureTable"]={"red","orange","yellow","green","blue","purple"}; end
  Recount:SetFont(Recount.db.profile.Font)
--RecountConfig
  local frm=CreateFrame("Frame",nil,Recount_ConfigWindow)
  frm:SetPoint("BOTTOM")
  frm:SetScript("OnShow",function() me:FixRecountConfigStuff(); RECOUNT_CONFIG_IS_SHOWN=1 end)
  frm:SetScript("OnHide", function() RECOUNT_CONFIG_IS_SHOWN=nil end)
--Detail
  Recount.DetailWindow.Alert=CreateFrame("Frame",nil,Recount_DetailWindow)
  local frm = Recount.DetailWindow.Alert
  frm:Hide()
  frm:SetPoint("TOPLEFT",Recount.MainWindow,"TOPLEFT",-2.5,-9.5)
  frm:SetPoint("BOTTOMRIGHT",Recount.MainWindow,"BOTTOMRIGHT",2.5,-2.5)
  frm:SetFrameStrata("HIGH")
  frm.Background=frm:CreateTexture(nil,"BACKGROUND")
  frm.Background:SetTexture(me.texPath.."blobb")
  frm.Background:SetAllPoints()
  frm.Text = frm:CreateFontString(nil,"ARTWORK","GameFontNormal")
  frm.Text:SetPoint("CENTER",0,5)
  frm.Text:SetText("Relaying details.\n\nClose details window\nor |cffffffffCLICK|r to\nregain control.")
  frm:SetScript("OnMouseDown", function(self) Recount.DetailWindow:Hide() end)
  frm:SetScript("OnHide", function(self) if Recount.DetailWindow.Hijacked then Recount:SetMainWindowMode(Recount.DetailWindow.Hijacked) end; Recount.DetailWindow.Hijacked=nil; self:Hide() end)
  --tinsert(UISpecialFrames, frm)
end)--SetScript

--SLASH COMMANDS STARTS
function rs_SlashCommands(cmd)
  me.Config:Show()
end--function

SLASH_RSBN1 = "/recountskin"
SLASH_RSBN2 = "/rs"
SLASH_RSBN3 = "/recountskinbynth"
SLASH_RSBN4 = "/skinbynth"
SlashCmdList.RSBN = rs_SlashCommands
--SLASH COMMANDS ENDS

--XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
-- Temporary Conversion Functions
-- for Outside Access to functions
   function rs_ShowTip(self,tip) me:ShowTip(self,tip) end
-- XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

   function me:RetVal(num) if 1024>num then num="|cffdddddd"..floor(num).."|rkb" else num="|cffffffff"..(format("%.1f", num / 1024)).."|rmb" end; return num end


        ---------------------------------------------
      -----IIIII------------------------II-------------
    ------II---II--II-II--IIII---IIII---IIII--IIII-------
  --------II-------III---II--II-----II--II---II--II--------
  --------II-------II----IIIIII--IIIII--II---IIIIII--------
    ------II---II--II----II-----II--II--II---II----------
      -----IIIII---II-----IIII---IIIII---II---IIII-----
        ---------------------------------------------

	  
function me:CreateConfigWindow()
  me.Config=CreateFrame("Frame", "RecountSkin_Config"..ID, UIParent)
  local Config=me.Config
  Config:Hide()
  Config:SetClampedToScreen(true)
  Config:EnableMouse(true)
  Config:SetToplevel(true)
  Config:SetSize(200,190)
	if not rs_saved["ConfigAnchor"] then rs_saved["ConfigAnchor"] = {"CENTER","UIParent","CENTER",0,0} end
    Config:SetPoint(unpack(rs_saved["ConfigAnchor"]))
	Config:SetMovable(true)
	Config:IsUserPlaced(true)
  Config.MemText=Config:CreateFontString(nil,"ARTWORK","GameFontNormal")
  Config.MemText:SetPoint("BOTTOMLEFT",8,3)
  Config.MemText:SetJustifyH("LEFT")
--Scripts Config
    Config.elapsed=0
	Config.update=0.1
	Config.recountPeak=0
	Config.skinPeak=0
    Config:SetScript("OnUpdate", function(self,elapsed) 
          self.elapsed=self.elapsed+elapsed
	      if self.update>self.elapsed then return else self.elapsed=0 end
	      --if not IsAddOnLoaded(self:GetText()) then return end
	      UpdateAddOnMemoryUsage()
		  
	      self.recountMem = GetAddOnMemoryUsage("Recount")
		    if self.recountMem > self.recountPeak then self.recountPeak = self.recountMem end
		  self.skinMem = GetAddOnMemoryUsage("RecountSkinByNth")
		    if self.skinMem > self.skinPeak then self.skinPeak = self.skinMem end
		  
		  Config.MemText:SetText("|cff999999Memory usage|r\nSkin: "..RecountSkin:RetVal(self.skinMem or 0) .." | Recount: "..RecountSkin:RetVal(self.recountMem or 0))
		  --self.cputime = GetAddOnCPUUsage(self:GetText()) - self.cputime
	      --if self.cputime > MemoryByNth.cputime then MemoryByNth.cputime=self.cputime end
		  
	      --self.Current:SetText(MemoryByNth:RetVal(self.current or 0))
	      --self.Peak:SetText(MemoryByNth:RetVal(self.peak or 0))
          --self.CPU:SetWidth((self:GetWidth()+12)*(self.cputime/MemoryByNth.cputime)+0.000001)
	end)--SetScript OnUpdate	  
--Background
  Config.Background=CreateFrame("Frame",nil,Config)
	Config.Background:SetPoint("TOPLEFT",-12,0)
	Config.Background:SetPoint("BOTTOMRIGHT",12,-12)
	Config.Background:SetFrameLevel(Config:GetFrameLevel()-1)
	me:FixFrameBackdrop(Config.Background)
--TitleBar
  Config.TitleBar=Config:CreateTexture(nil,"ARTWORK")
	Config.TitleBar:SetPoint("TOPLEFT",-4,-10)
	Config.TitleBar:SetPoint("RIGHT",4,0)
	Config.TitleBar:SetHeight(22)
	Config.TitleBar:SetColorTexture(1,1,1)
    Config.TitleBar:SetGradientAlpha("VERTICAL",0.25,0.25,0.25,1,0.25,0.25,0.25,0)
--Title
  Config.Title=Config:CreateFontString(nil,"ARTWORK","GameFontNormal")
    Config.Title:SetPoint("TOPLEFT",6,-15)
	Config.Title:SetText("RecountSkin|cff888888ByNth|r Config")
	Config.Title:SetTextColor(1,1,1,1)
    Recount:AddFontString(Config.Title)
    Config.TitleClick=CreateFrame("Frame",nil,Config)
    Config.TitleClick:SetAllPoints(Config.Title)
  --SCRIPTS TitleClick
    Config.TitleClick:SetScript("OnEnter",function(self) me:ShowTip(self, "Move the config window") end)
    Config.TitleClick:SetScript("OnLeave",function(self) me:ShowTip() end)
    Config.TitleClick:SetScript("OnMouseDown",function(self,button) self:GetParent():StartMoving()end)
    Config.TitleClick:SetScript("OnMouseUp",function(self) self:GetParent():StopMovingOrSizing(); rs_saved["ConfigAnchor"]={"TOPLEFT","UIParent","BOTTOMLEFT",self:GetParent():GetLeft(),self:GetParent():GetTop()} end)
--Buttons
      Config.ExitButton=CreateFrame("Button",nil,Config)
      Config.ExitButton:SetSize(16,16)
	  Config.ExitButton:SetNormalTexture(me.texPath.."exit_normal")
	  Config.ExitButton:SetHighlightTexture(me.texPath.."exit_normal","ADD")
	  Config.ExitButton:SetPoint("TOPRIGHT",-4,-12)
  --SCRIPTS Buttons
    Config.ExitButton:SetScript("OnEnter",function(self) me:ShowTip(self, "Hide config") end)
	Config.ExitButton:SetScript("OnLeave",function(self) me:ShowTip() end)
	Config.ExitButton:SetScript("OnClick",function(self) self:GetParent():Hide() end)
--Option Controls
  Config.Check1=CreateFrame("CheckButton","rs_ConfigWindowCheck1",Config,"rs_ReportCheckButtonTemplate")
	Config.Check1:SetPoint("TOPLEFT",6,-38)
	Config.Check1.Text:SetText("Disable Tooltips")
	Config.Check1.setting="killtooltip"
	Config.Check1:SetScript("OnClick",function(self)
	  if self:GetChecked() then
	    rs_saved[self.setting]=1;
		Config.Check2:SetEnabled(true)
		Config.Check2.Text:SetTextColor(1,1,1,1)
	  else
	    rs_saved[self.setting]=nil;
		Config.Check2:SetEnabled(false)
		Config.Check2.Text:SetTextColor(1,1,1,0.25)
      end
	end)--SetScript OnClick
	Config.Check1:SetScript("OnEnter", function(self) me:ShowTip(self, "Disables tooltips added by the RecountSkinByNth addon.\n(Excluding ones with modifier info and config)",1) end)
	Config.Check1:SetScript("OnLeave",function(self) me:ShowTip()  end)
	Config.Check1:SetScript("OnShow",function(self) if rs_saved[self.setting] then self:SetChecked(true) else self:SetChecked(false) end end)
  Config.Check2=CreateFrame("CheckButton","rs_ConfigWindowCheck2",Config,"rs_ReportCheckButtonTemplate")
	Config.Check2:SetPoint("TOPLEFT",6+14,-52)
	Config.Check2.Text:SetText("Incl. ones with modifier info")
	Config.Check2.setting="killmodtooltip"
	Config.Check2:SetScript("OnClick",function(self) if self:GetChecked() then rs_saved[self.setting]=1 else rs_saved[self.setting]=nil end me:UpdateRecountConfigRelated() end)--SetScript OnClick
	Config.Check2:SetScript("OnEnter", function(self) me:ShowTip(self, "Disables ALL tooltips added by the RecountSkinByNth addon)",1) end)
	Config.Check2:SetScript("OnLeave",function(self) me:ShowTip()  end)
    Config.Check2:SetScript("OnShow",function(self)
	  if rs_saved[Config.Check1.setting] then self:SetEnabled(true);Config.Check2.Text:SetTextColor(1,1,1,1) else self:SetEnabled(false);Config.Check2.Text:SetTextColor(1,1,1,0.25) end
	  if rs_saved[self.setting] then self:SetChecked(true) else self:SetChecked(false) end
	end)--SetScript
  Config.Check3=CreateFrame("CheckButton","rs_ConfigWindowCheck3",Config,"rs_ReportCheckButtonTemplate")
	Config.Check3:SetPoint("TOPLEFT",6,-72)
	Config.Check3.Text:SetText("Disable custom report tool")
	Config.Check3.setting="userecountreport"
	Config.Check3:SetScript("OnClick",function(self) if self:GetChecked() then rs_saved[self.setting]=1 else rs_saved[self.setting]=nil end me:UpdateRecountConfigRelated() end)--SetScript OnClick
	Config.Check3:SetScript("OnEnter", function(self) me:ShowTip(self, "Disables the RecountSkinByNth's custom report tool\n(disables initiation of reports from all other windows than Recount)",1) end)
	Config.Check3:SetScript("OnLeave",function(self) me:ShowTip()  end)
    Config.Check3:SetScript("OnShow",function(self) if rs_saved[self.setting] then self:SetChecked(true) else self:SetChecked(false) end end)

  Config.Check4=CreateFrame("CheckButton","rs_ConfigWindowCheck4",Config,"rs_ReportCheckButtonTemplate")
	Config.Check4:SetPoint("TOPLEFT",6,-92)
	Config.Check4.Text:SetText("Disable bar merged overlay")
	Config.Check4.setting="usemergedoverlay"
	Config.Check4:SetScript("OnClick",function(self)if self:GetChecked() then
	    rs_saved[self.setting]=1;
		Config.Check5:SetEnabled(true)
		Config.Check5.Text:SetTextColor(1,1,1,1)
	  else
	    rs_saved[self.setting]=nil;
		Config.Check5:SetEnabled(false)
		Config.Check5.Text:SetTextColor(1,1,1,0.25)
      end
	end)--SetScript OnClick
	Config.Check4:SetScript("OnEnter", function(self) me:ShowTip(self, "Disables the merged overlay indicators on bars.\nAbsorbs for Healing Done, and Pet Damage for Damage Done.\nThis does NOT disable data merging",1) end)
	Config.Check4:SetScript("OnLeave",function(self) me:ShowTip()  end)
    Config.Check4:SetScript("OnShow",function(self) if rs_saved[self.setting] then self:SetChecked(true) else self:SetChecked(false) end end)

  Config.Check5=CreateFrame("CheckButton","rs_ConfigWindowCheck4",Config,"rs_ReportCheckButtonTemplate")
	Config.Check5:SetPoint("TOPLEFT",6+14,-106)
	Config.Check5.Text:SetText("Incl. bar on details tooltip")
	Config.Check5.setting="usetooltipmergedoverlay"
	Config.Check5:SetScript("OnClick",function(self) if self:GetChecked() then rs_saved[self.setting]=1 else rs_saved[self.setting]=nil end me:UpdateRecountConfigRelated() end)--SetScript OnClick
	Config.Check5:SetScript("OnEnter", function(self) me:ShowTip(self, "Disables the merged overlay indicators the details tooltip also.",1) end)
	Config.Check5:SetScript("OnLeave",function(self) me:ShowTip()  end)
    Config.Check5:SetScript("OnShow",function(self)
	  if rs_saved[Config.Check4.setting] then self:SetEnabled(true);Config.Check2.Text:SetTextColor(1,1,1,1) else self:SetEnabled(false);self.Text:SetTextColor(1,1,1,0.25) end
	  if rs_saved[self.setting] then self:SetChecked(true) else self:SetChecked(false) end
	end)--SetScript
	
  Config.ResetPosButton=CreateFrame("Button","rs_ConfigWindowButton2",Config,"UIPanelButtonTemplate")
    Config.ResetPosButton:SetSize(100,24)
    me:FixButtonTextures(Config.ResetPosButton,0.5,0,0)
	Config.ResetPosButton:SetPoint("BOTTOMLEFT",6,30)
	Config.ResetPosButton:SetText("Reset pos")
	Config.ResetPosButton:SetScript("OnEnter", function(self) me:ShowTip(self, "Resets window position and size for all extra windows\n(Use '/recount resetpos' for actual Recount windows)",1) end)
	Config.ResetPosButton:SetScript("OnLeave",function(self) me:ShowTip() end)
	Config.ResetPosButton:SetScript("OnClick", function(self) me:ResetWindowPos() end)
	
end--function

function me:FixButton(button,width,height)
    if width then button:SetWidth(width) end
	if height then button:SetHeight(height) end
  --Removes (hides) All Textures from a frame
	local Rgns = { button:GetRegions() };
	for _, rgn in ipairs(Rgns) do if rgn:IsObjectType("texture") and rgn:GetDrawLayer()~="HIGHLIGHT" then rgn:SetTexture(""); rgn:Hide() end end--do
    button.Left:SetTexture("");button.Middle:SetTexture("");button.Right:SetTexture("")
    button:SetBackdrop({bgFile = "Interface\\AddOns\\RecountSkinByNth\\textures\\menu_button_background", edgeFile = "Interface\\AddOns\\RecountSkinByNth\\textures\\menu_button_border", tile = true, tileSize = 8, edgeSize = 8, insets = { left = 8, right = 8, top = 8, bottom = 8 }});
	button:SetBackdropColor(0.2,0.2,0.2,1);
	button:SetBackdropBorderColor(0.2,0.2,0.2,1);
	button:SetHighlightTexture("Interface\\AddOns\\RecountSkinByNth\\textures\\menu_button_highlight")
end--function

function me:CreateWindow()
--The Frame
  local ID=#me.Windows+1
  if ID==table.maxn(Recount.MainWindowData)-1 then --Just Limit Window Count to 10 to be sure
    print("|cffffcc00Recount|rSkinByNth ->|cff888888 Window limit reached. (one for each stat)");
    return
  end
  me.Windows[ID]=CreateFrame("Frame", "RecountSkin_Window"..ID, Recount.MainWindow)
  local frame=me.Windows[ID]
    frame:Hide()
	frame:SetClampedToScreen(true)
    frame:SetID(ID)
    frame:EnableMouse(true)
    frame:SetToplevel(true)
	if ID==1 then frame:SetMinResize(140, 98) else frame:SetMinResize(100, 98) end
	Recount.MainWindow:SetMinResize(140, 98) --Prevents detaching scrollbar syndrome.
	frame:SetMaxResize(400, 520)
	if not rs_saved["Mode"][ID] then rs_saved["Mode"][ID]=1 end
	
	if rs_saved.WindowSize[ID] then frame:SetSize(unpack(rs_saved.WindowSize[ID])) else frame:SetSize(200,150) end
	frame:SetResizable(true)
	frame:ClearAllPoints()
	if not rs_saved["Anchor"][ID] then rs_saved["Anchor"][ID] = {"CENTER","UIParent","CENTER",-150+((ID-1)*15),150-((ID-1)*15)} end
    frame:SetPoint(unpack(rs_saved["Anchor"][ID]))
	frame:SetMovable(true)
	frame:IsUserPlaced(true)	
--Background
  frame.Background=CreateFrame("Frame",nil,frame)
	frame.Background:SetPoint("TOPLEFT",-12,0)
	frame.Background:SetPoint("BOTTOMRIGHT",12,-12)
	frame.Background:SetFrameLevel(frame:GetFrameLevel()-1)
	me:FixFrameBackdrop(frame.Background)
--Title
  frame.Title=frame:CreateFontString(nil,"ARTWORK","GameFontNormal")
    frame.Title:SetPoint("TOPLEFT",6,-15)
	frame.Title:SetText("Title")
	frame.Title:SetTextColor(1,1,1,1)
    Recount:AddFontString(frame.Title)
    frame.TitleClick=CreateFrame("Frame",nil,frame)
    frame.TitleClick:SetAllPoints(frame.Title)
  --SCRIPTS TitleClick
    frame.TitleClick:SetScript("OnEnter",function(self) me:ShowTip(self, "Select statistic | Move") end)
    frame.TitleClick:SetScript("OnLeave",function(self) me:ShowTip() end)
    frame.TitleClick:SetScript("OnMouseDown",function(self,button)
      if button=="RightButton" then
        if rs_SelectModeWindow:IsVisible() then rs_SelectModeWindow:Hide() else rs_SelectModeWindow.target=ID; rs_SelectModeWindow:Show() end
	  else
	    local x,y=GetCursorPosition()
	    self.x=floor(x); self.y=floor(y)
	    self:GetParent():StartMoving()
	  end
    end)
    frame.TitleClick:SetScript("OnMouseUp",function(self)
      self:GetParent():StopMovingOrSizing()
	  local x,y=GetCursorPosition()
	  if self.x==floor(x) and self.y==floor(y) then
	    if rs_SelectModeWindow:IsVisible() then rs_SelectModeWindow:Hide() else rs_SelectModeWindow.target=ID; rs_SelectModeWindow:Show() end
	  end
	  self.x=0; self.y=0
	  local left,top
	  left = self:GetParent():GetLeft() -- * UIParent:GetScale() / self:GetEffectiveScale()
	  top = self:GetParent():GetTop()-- * UIParent:GetScale() / self:GetEffectiveScale()
	  rs_saved["Anchor"][self:GetParent():GetID()]={"TOPLEFT","UIParent","BOTTOMLEFT",left,top }
    end)
--Buttons
  local bNames={"ExitButton","NextButton","PreviousButton","ReportButton","DragButtonLeft","DragButtonRight"}
  local bTex={me.texPath.."exit_normal",me.texPath.."next_normal",me.texPath.."previous_normal",me.texPath.."report_normal","Interface\\AddOns\\Recount\\textures\\ResizeGripLeft","Interface\\AddOns\\Recount\\textures\\ResizeGripRight"}
    for i,name in pairs(bNames) do
      frame[name]=CreateFrame("Button",nil,frame)
      frame[name]:SetSize(16,16)
	  frame[name]:SetNormalTexture(bTex[i])
	  frame[name]:SetHighlightTexture(bTex[i],"ADD")
      if i==1 then frame[name]:SetPoint("TOPRIGHT",-4,-12) elseif i<=4 then frame[name]:SetPoint("TOPRIGHT",frame[bNames[i-1]],"TOPLEFT",0,0) end
    end
    frame.DragButtonLeft:SetPoint("BOTTOMLEFT",-7,-7)
    frame.DragButtonRight:SetPoint("BOTTOMRIGHT",7,-7)
  --SCRIPTS Buttons
    frame.ExitButton:SetScript("OnEnter",function(self) me:ShowTip(self, "Hide this window("..ID..")") end)
	frame.ExitButton:SetScript("OnLeave",function(self) me:ShowTip() end)
	frame.ExitButton:SetScript("OnClick",function(self) me:CloseWindow(self:GetParent():GetID()) end)
	frame.NextButton:SetScript("OnEnter",function(self) me:ShowTip(self, "Show next stat") end)
	frame.NextButton:SetScript("OnLeave",function(self) me:ShowTip() end)
	frame.NextButton:SetScript("OnClick",function(self) me:SetMode(rs_saved["Mode"][self:GetParent():GetID()]+1, self:GetParent():GetID()) end)
	frame.PreviousButton:SetScript("OnEnter",function(self) me:ShowTip(self, "Show previous stat") end)
	frame.PreviousButton:SetScript("OnLeave",function(self) me:ShowTip() end)
	frame.PreviousButton:SetScript("OnClick",function(self) me:SetMode(rs_saved["Mode"][self:GetParent():GetID()]-1, self:GetParent():GetID()) end)
	frame.ReportButton:SetScript("OnEnter",function(self) me:ShowTip(self, "Initiate report") end)
	frame.ReportButton:SetScript("OnLeave",function(self) me:ShowTip() end)
	frame.ReportButton:SetScript("OnClick",function(self) me:ReportFuntion(self:GetParent():GetID()) end)
	frame.DragButtonLeft:SetScript("OnMouseDown",function(self) self:GetParent():StartSizing("BOTTOMLEFT") end)
	frame.DragButtonLeft:SetScript("OnMouseUp",function(self)
	  self:GetParent():StopMovingOrSizing()
	  local left,top
	  left = self:GetParent():GetLeft() -- * UIParent:GetScale() / self:GetEffectiveScale()
	  top = self:GetParent():GetTop()-- * UIParent:GetScale() / self:GetEffectiveScale()
	  rs_saved["Anchor"][self:GetParent():GetID()]={"TOPLEFT","UIParent","BOTTOMLEFT",left,top }
	end)
	frame.DragButtonRight:SetScript("OnMouseDown",function(self) self:GetParent():StartSizing("BOTTOMRIGHT") end)
	frame.DragButtonRight:SetScript("OnMouseUp",function(self) self:GetParent():StopMovingOrSizing() end)
--ScrollFrame
  frame.ScrollFrame = CreateFrame("ScrollFrame", "rs_ScollFrame"..ID, frame, "FauxScrollFrameTemplate")
	frame.ScrollFrame:SetPoint("TOPRIGHT",-26,0)
	frame.ScrollFrame:SetSize(10,10)
	frame.ScrollFrameScrollBar=_G[frame.ScrollFrame:GetName().."ScrollBar"]
	Recount:SetupScrollbar(frame.ScrollFrame:GetName())
	me:FixVerticalScrollBar(frame.ScrollFrameScrollBar,"noBg")
  --SCRIPTS ScrollFrame
	frame.ScrollFrame:SetScript("OnVerticalScroll", function(self, offset) FauxScrollFrame_OnVerticalScroll(self, offset, 20, me:ResizeWindow(self:GetParent())) end)
	--Bars
  me:CreateSecWinBars(frame)
--SCRIPTS FRAME
  frame.update=0.2 -- 5 times a sec
  frame.elapsed=0
  frame:SetScript("OnSizeChanged", function(self) me:ResizeWindow(self) end)
  frame:SetScript("OnShow",function(self) local i=self:GetID();rs_saved["Shown"][i]=1; me:SetMode(rs_saved["Mode"][i] or 1,i); if i~=1 then return end; me.ToggleButton:SetNormalTexture(me.texPath.."closewindow_normal"); me.ToggleButton:SetHighlightTexture(me.texPath.."closewindow_normal","ADD"); me:UpdateRecountConfigRelated() end)
  frame:SetScript("OnHide",function(self) local i=self:GetID(); if i~=1 then return end; me.ToggleButton:SetNormalTexture(me.texPath.."openwindow_normal"); me.ToggleButton:SetHighlightTexture(me.texPath.."openwindow_normal","ADD") end)
  frame:SetScript("OnUpdate",function(self,elapsed) self.elapsed=self.elapsed + elapsed; if self.update>self.elapsed then return else self.elapsed=0 end me:RefreshWindow(self) end);
  
  --print("created: "..ID)
  
  if ID~=1 then
    me:UpdateRecountConfigRelated()
    frame:Show()
  else
    if rs_saved["Shown"][ID] then
	  me.ToggleButton:SetNormalTexture(me.texPath.."closewindow_normal");
	  me.ToggleButton:SetHighlightTexture(me.texPath.."closewindow_normal","ADD")
	  frame:Show()
    end--if
  end--if
end--function me.CreateWindow()

function me:ResetWindowPos()
  rs_saved["Anchor"]={}
  rs_saved["WindowSize"]={}
  for i=1,table.maxn(Recount.MainWindowData)-1 do
    if me.Windows[i] then
	  me.Windows[i]:ClearAllPoints()
	  me.Windows[i]:SetPoint("CENTER",UIParent,"CENTER",-150+((i-1)*15),150-((i-1)*15))
	  me.Windows[i]:SetSize(200,150)
	  me.Windows[i]:Raise()
	end
  end
end--function

function me:NewWindow()
  local hiddenOne=nil
	  for i=1,#me.Windows do
	    if not me.Windows[i]:IsShown() then hiddenOne=i; break end
	  end
	  if hiddenOne then
	    me.Windows[hiddenOne]:ClearAllPoints()
	    me.Windows[hiddenOne]:SetPoint(unpack(rs_saved["Anchor"][hiddenOne] or {"CENTER","UIParent","CENTER",-150+((hiddenOne-1)*15),150-((hiddenOne-1)*15)}))
	    me.Windows[hiddenOne]:SetSize(unpack(rs_saved["WindowSize"][hiddenOne]or {200,150}))
	    me.Windows[hiddenOne]:Show()
	  else
	    me:CreateWindow()
	  end
end--function

function me:CloseWindow(ID)
    local OpenWindows=1
    for i=2, #me.Windows do if me.Windows[i]:IsShown() then OpenWindows=OpenWindows+1 end end
	
  if ID~=1 and ID<OpenWindows then
    local oldMode, oldAnchor, oldSize = rs_saved["Mode"][ID], rs_saved["Anchor"][ID], rs_saved["WindowSize"][ID]
    tremove(rs_saved["Shown"], ID)
    tremove(rs_saved["Mode"], ID)
	tremove(rs_saved["Anchor"], ID)
	tremove(rs_saved["WindowSize"], ID)

	  tinsert(rs_saved["Mode"], OpenWindows, oldMode)
	  tinsert(rs_saved["Anchor"], OpenWindows, oldAnchor)
	  tinsert(rs_saved["WindowSize"], OpenWindows, oldSize)	

	for i=2,#me.Windows do me.Windows[i]:Hide() end
	
	for i=2,#rs_saved["Shown"] do
	    me.Windows[i]:ClearAllPoints()
	    me.Windows[i]:SetPoint(unpack(rs_saved["Anchor"][i] or {"CENTER","UIParent","CENTER",-150+((i-1)*15),150-((i-1)*15)}))
	    me.Windows[i]:SetSize(unpack(rs_saved["WindowSize"][i]or {200,150}))
	    me.Windows[i]:Show()
	end
  else
    me.Windows[ID]:Hide()
    rs_saved["Shown"][ID]=nil
  end
end--function

function me:CreateSecWinBars(frame)
  frame.Bars={}
  frame.BarData={}
  frame.Offset=0
	for i=0,30 do
	  frame.Bars[i]=CreateFrame("StatusBar",nil,frame)
	  frame.Bars[i]:SetID(i)
	  if i==0 then frame.Bars[i]:SetPoint("BOTTOMLEFT",frame.ScrollFrame,"TOPLEFT",0,0) elseif i==1 then frame.Bars[i]:SetPoint("TOPLEFT",frame.ScrollFrame,"TOPLEFT",0,0) else frame.Bars[i]:SetPoint("TOPLEFT",frame.Bars[i-1],"BOTTOMLEFT",0,0) end
		frame.Bars[i]:SetPoint("RIGHT",frame.ScrollFrame,"RIGHT",4,0)
		frame.Bars[i]:SetHeight(Recount.db.profile.MainWindow.RowHeight + Recount.db.profile.MainWindow.RowSpacing)
		frame.Bars[i].TextLeft = frame.Bars[i]:CreateFontString(nil,"ARTWORK","GameFontNormal")
		frame.Bars[i].TextLeft:SetPoint("LEFT",3,0)
		frame.Bars[i].TextRight = frame.Bars[i]:CreateFontString(nil,"ARTWORK","GameFontNormal")
		frame.Bars[i].TextRight:SetPoint("RIGHT",-3,0)
		frame.Bars[i].BarTexture = frame.Bars[i]:CreateTexture(nil,"BACKGROUND")
		frame.Bars[i].BarTexture:SetPoint("TOPLEFT")
		frame.Bars[i].BarTexture:SetPoint("BOTTOMLEFT",0, Recount.db.profile.MainWindow.RowSpacing)
		frame.Bars[i].BarTexture:SetWidth(0.000001)
		frame.Bars[i].MergedTexture = frame.Bars[i]:CreateTexture(nil,"ARTWORK")
		frame.Bars[i].MergedTexture:SetPoint("TOPRIGHT",frame.Bars[i].BarTexture,"TOPRIGHT")
		frame.Bars[i].MergedTexture:SetPoint("BOTTOMRIGHT",frame.Bars[i].BarTexture,"BOTTOMRIGHT")
		frame.Bars[i].MergedTexture:SetWidth(0.000001)
		frame.Bars[i].MergedTexture:SetColorTexture(1,1,1,1)
		frame.Bars[i].MergedTexture:SetGradientAlpha("HORIZONTAL", 0, 0, 0, 0.25, 0, 0, 0, 0) 
	  --HighLight
		frame.Bars[i].Highlight=frame.Bars[i]:CreateTexture(nil,"HIGHLIGHT",nil,"ADD")
		frame.Bars[i].Highlight:SetAllPoints()
		frame.Bars[i].Highlight:SetColorTexture(1,1,1,0.1)
		--Recount:AddFontString(frame.Bars[i].TextLeft)
		--Recount:AddFontString(frame.Bars[i].TextRight)
		frame.Bars[i].elapsed=0; frame.Bars[i].update=0.1
		frame.Bars[i]:SetScript("OnUpdate", function(self,elapsed) self.elapsed=self.elapsed+elapsed if self.update>self.elapsed then return else self.elapsed=0 end me:BarUpdate(self, elapsed, self:GetParent():GetID()) end)
	    frame.Bars[i]:SetScript("OnEnter", function(self) me:ShowCombatDetails(self) end)
	    frame.Bars[i]:SetScript("OnLeave", function(self) me:ShowCombatDetails() end)
		frame.Bars[i]:SetScript("OnMouseDown", function(self) me:ShowRecountDetails(self.WholeName, self:GetParent():GetID()) end)
	end--do
	IS_BARS_LOADED[frame:GetID()]=1
end--function me:CreateSecWinBars()

-- XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

function me:UpdateRecountConfigRelated()
    me:ArrangeMainWindowData() 	--me.MainWindowData --Selectable Modes, updated from Config Window
	local BarTexture = Recount.db.profile.BarTexture
	if BarTexture == nil then me.BarTexture = SM:Fetch("statusbar", "BantoBar") else me.BarTexture = SM:Fetch("statusbar", BarTexture) end
	
	for ID = 1,#me.Windows do
	  local frame=me.Windows[ID]
	  if RecountResizeGripRight:IsVisible() then frame.DragButtonRight:Show(); frame.DragButtonLeft:Show() else frame.DragButtonRight:Hide(); frame.DragButtonLeft:Hide() end
	  if Recount.db.profile.MainWindow.HideTotalBar==true then
	    frame.Bars[0]:Hide(); frame.ScrollFrame:SetPoint("TOPLEFT",2,-32.95)
	  else
	    frame.Bars[0]:Show(); frame.ScrollFrame:SetPoint("TOPLEFT",2,-32.95-(Recount.db.profile.MainWindow.RowHeight + Recount.db.profile.MainWindow.RowSpacing))
	  end
	  for i=0,30 do
	    me.Windows[ID].Bars[i].BarTexture:SetTexture(me.BarTexture)
		me.Windows[ID].Bars[i]:SetHeight(Recount.db.profile.MainWindow.RowHeight + Recount.db.profile.MainWindow.RowSpacing)
		me.Windows[ID].Bars[i].BarTexture:SetPoint("BOTTOMLEFT",0,Recount.db.profile.MainWindow.RowSpacing)
		local fontHeight=math.max(Recount.db.profile.MainWindow.RowHeight * 0.75, Recount.db.profile.MainWindow.RowHeight - 3)
		local Font,_,Flags=Recount.MainWindow.Rows[1].LeftText:GetFont()
		me.Windows[ID].Bars[i].TextLeft:SetFont(Font,fontHeight,Flags)
		me.Windows[ID].Bars[i].TextRight:SetFont(Font,fontHeight,Flags)
	  end
	  me:ResizeWindow(me.Windows[ID])
		if Recount.MainWindow.RightButton:IsVisible() then me.Windows[ID].NextButton:SetScale(1) else me.Windows[ID].NextButton:SetScale(0.0001) end
		if Recount.MainWindow.LeftButton:IsVisible() then me.Windows[ID].PreviousButton:SetScale(1) else me.Windows[ID].PreviousButton:SetScale(0.0001) end
		if Recount.MainWindow.ReportButton:IsVisible() then me.Windows[ID].ReportButton:SetScale(1) else me.Windows[ID].ReportButton:SetScale(0.0001) end	
    end--do
  --Fights Button
	if Recount.db.profile.CurDataSet=="OverallData" then
	  me:ChangeRecountControlTextures(Recount.MainWindow.FileButton,"overall",1)
	elseif Recount.db.profile.CurDataSet=="LastFightData" or Recount.db.profile.CurDataSet=="CurrentFightData" then
	  me:ChangeRecountControlTextures(Recount.MainWindow.FileButton,"lastfight",1)
	else
	  me:ChangeRecountControlTextures(Recount.MainWindow.FileButton,"fight",1)
	end
 
	for i=1,#Recount.MainWindow.Rows do
	--Bars Highlights
	  if Recount.MainWindow.Rows[i] and not Recount.MainWindow.Rows[i].Highlight then
	    Recount.MainWindow.Rows[i].Highlight=Recount.MainWindow.Rows[i]:CreateTexture(nil,"HIGHLIGHT",nil,"ADD")
		Recount.MainWindow.Rows[i].Highlight:SetAllPoints()
		Recount.MainWindow.Rows[i].Highlight:SetColorTexture(1,1,1,0.1)
		  --Remember this to activate Tooltip on Recount.MainWindow
		  Recount.MainWindow.Rows[i]:SetScript("OnEnter",function(self) me:ShowCombatDetails(self,1) end)
		  Recount.MainWindow.Rows[i]:SetScript("OnLeave",function(self) me:ShowCombatDetails() end) 
	  end--if
	--Merged Textures  (update with the ToggleButton)
	  if not Recount.MainWindow.Rows[i].StatusBar.MergedTexture then
		Recount.MainWindow.Rows[i].StatusBar.MergedTexture = Recount.MainWindow.Rows[i].StatusBar:CreateTexture(nil,"OVERLAY")
		local Rgns = { Recount.MainWindow.Rows[i].StatusBar:GetRegions() };
		for _, rgn in ipairs(Rgns) do
		  if rgn:IsObjectType("texture") then
			Recount.MainWindow.Rows[i].StatusBar.MergedTexture:SetPoint("TOPRIGHT",rgn,"TOPRIGHT")
		    Recount.MainWindow.Rows[i].StatusBar.MergedTexture:SetPoint("BOTTOMRIGHT",rgn,"BOTTOMRIGHT")
			break
		  end
		end--do
		Recount.MainWindow.Rows[i].StatusBar.MergedTexture:SetWidth(0.0001)
		Recount.MainWindow.Rows[i].StatusBar.MergedTexture:SetColorTexture(1,1,1,1)
		Recount.MainWindow.Rows[i].StatusBar.MergedTexture:SetGradientAlpha("HORIZONTAL", 0, 0, 0, 0.25, 0, 0, 0, 0) 
        MERGED_TEXTURES_CREATED=i		
	  end
	end--do
  --TitleBar Color
    if me.RecountTitleBar then
	  local C=Recount.db.profile.Colors.Window.Title
      local r,g,b,a=C.r,C.g,C.b,C.a
      me.RecountTitleBar:SetGradientAlpha("VERTICAL",r,g,b,a,r,g,b,0)
	end
	if Recount.ConfigWindow.TitleBar then
	  local C=Recount.db.profile.Colors["Other Windows"].Title
      local r,g,b,a=C.r,C.g,C.b,C.a
	  Recount.ConfigWindow.TitleBar:SetGradientAlpha("VERTICAL",r,g,b,a,r,g,b,0)
	end
	if Recount.ResetFrame and Recount.ResetFrame.TitleBar then
	  local C=Recount.db.profile.Colors["Other Windows"].Title
      local r,g,b,a=C.r,C.g,C.b,C.a
	  Recount.ResetFrame.TitleBar:SetGradientAlpha("VERTICAL",r,g,b,a,r,g,b,0)
	end
  --Title and Icon Colors
    if me.RecountTitleBar then
	  local C=Recount.db.profile.Colors.Window["Title Text"]
      local r,g,b,a=C.r,C.g,C.b,C.a
	  me:SetColorToIcon("RightButton",r,g,b)
	  me:SetColorToIcon("LeftButton",r,g,b)
	  me:SetColorToIcon("ResetButton",r,g,b)
	  me:SetColorToIcon("FileButton",r,g,b)
	  me:SetColorToIcon("ConfigButton",r,g,b)
	  me:SetColorToIcon("ReportButton",r,g,b)
	  for i=1,#me.Windows do
	    me.Windows[i].Title:SetTextColor(r,g,b,a)
	    me:SetColorToIcon("NextButton",r,g,b,i)
	    me:SetColorToIcon("PreviousButton",r,g,b,i)
	    me:SetColorToIcon("ReportButton",r,g,b,i)
		if rs_saved["userecountreport"] then me.Windows[i].ReportButton:SetAlpha(0.25) else me.Windows[i].ReportButton:SetAlpha(1) end
	  end
	end
  --Background Color
    if Recount_MainWindow_Background then
      local C=Recount.db.profile.Colors.Window.Background
      local r,g,b,a=C.r,C.g,C.b,C.a
      Recount_MainWindow_Background:SetBackdropColor(r,g,b,a)
	  Recount_MainWindow_Background:SetBackdropBorderColor(r,g,b,a)
	  for i=1,#me.Windows do
	    me.Windows[i].Background:SetBackdropColor(r,g,b,a)
		me.Windows[i].Background:SetBackdropBorderColor(r,g,b,a)
	  end
	end
    if Recount.ConfigWindow and Recount.ConfigWindow.Background then
      local C=Recount.db.profile.Colors["Other Windows"].Background
      local r,g,b,a=C.r,C.g,C.b,C.a
      Recount.ConfigWindow.Background:SetBackdropColor(r,g,b,a)
	  Recount.ConfigWindow.Background:SetBackdropBorderColor(r,g,b,a)
	end
	if Recount.ResetFrame and Recount.ResetFrame.Background then
      local C=Recount.db.profile.Colors["Other Windows"].Background
      local r,g,b,a=C.r,C.g,C.b,C.a
      Recount.ResetFrame.Background:SetBackdropColor(r,g,b,a)
	  Recount.ResetFrame.Background:SetBackdropBorderColor(r,g,b,a)
	end
end--function me:UpdateRecountConfigRelated()

function me:ShowRecountDetails(name, windowID)
  if not name then return end
  Recount.MainWindow.Selected = name
  if RecountStat~=rs_saved["Mode"][windowID] and not Recount.DetailWindow.Hijacked then
	Recount.DetailWindow.Hijacked=Recount.db.profile.MainWindowMode
	Recount.DetailWindow.Alert:Show()
  end
  Recount.DetailWindow:Show()
  Recount:SetMainWindowMode(rs_saved["Mode"][windowID])
end--function

function me:RemoveAllTexturesFromFrame(frm)
  --Removes (hides) All Textures from a frame
	local Rgns = { frm:GetRegions() };
	for _, rgn in ipairs(Rgns) do
	  if rgn:IsObjectType("texture") and rgn:GetDrawLayer()~="HIGHLIGHT" then rgn:SetTexture(""); rgn:Hide() end
	end--do
end--function

function me:FixFrameBackdrop(frm,col)
    frm:SetBackdrop({bgFile = "Interface\\AddOns\\RecountSkinByNth\\textures\\background", edgeFile = "Interface\\AddOns\\RecountSkinByNth\\textures\\border", tile = true, tileSize = 16, edgeSize = 16, insets = { left = 16, right = 16, top = 16, bottom = 16 }});
	frm:SetBackdropColor(col or 0.1, col or 0.1, col or 0.1, 1);
	frm:SetBackdropBorderColor(col or 0.1, col or 0.1, col or 0.1, 1);
end--function

function me:FixButtonTextures(button,r,g,b)
  if button.Left then button.Left:Hide() end
  if button.Middle then button.Middle:Hide() end
  if button.Right then button.Right:Hide() end
  
    button.Background=CreateFrame("Frame",nil,button)
	button.Background:SetPoint("TOPLEFT",-5,5)
	button.Background:SetPoint("BOTTOMRIGHT",5,-5)
	button.Background:SetFrameLevel(button:GetFrameLevel()-1)
	me:FixFrameBackdrop(button.Background)
    button.Background:SetBackdropBorderColor(r or 1,g or 1,b or 1)
	button.Background:SetBackdropColor(r or 1,g or 1,b or 1)
	button.Background.Fade=button.Background:CreateTexture(nil,"ARTWORK")
	button.Background.Fade:SetPoint("TOPLEFT",button.Background,"LEFT",9,1)
	button.Background.Fade:SetPoint("BOTTOMRIGHT",-9,7)
	button.Background.Fade:SetColorTexture(1,1,1)
	button.Background.Fade:SetGradientAlpha("VERTICAL",0,0,0,0,0,0,0,0.2)
end--function

function me:FixVerticalScrollBar(scrollbar, noBg, height)
      if not noBg then
	  scrollbar:SetBackdrop({bgFile = "Interface\\AddOns\\RecountSkinByNth\\textures\\menu_button_background", edgeFile = "", tile = true, tileSize = 8, edgeSize = 8, insets = { left = 0, right = 0, top = 0, bottom = 0 }});
	  scrollbar:SetBackdropColor(0,0,0,0.25);
	  end--if
	  
	  _G[scrollbar:GetName().."ThumbTexture"]:SetTexture("Interface\\AddOns\\RecountSkinByNth\\textures\\scroll_thumb_normal")
	  _G[scrollbar:GetName().."ThumbTexture"]:SetVertexColor(1,1,1,1)
	  _G[scrollbar:GetName().."ScrollUpButton"]:SetHeight(height or 16)
	  _G[scrollbar:GetName().."ScrollUpButton"]:SetNormalTexture("Interface\\AddOns\\RecountSkinByNth\\textures\\scroll_up_normal")
	  _G[scrollbar:GetName().."ScrollUpButton"]:SetDisabledTexture("Interface\\AddOns\\RecountSkinByNth\\textures\\scroll_up_disabled")
	  _G[scrollbar:GetName().."ScrollUpButton"]:SetPushedTexture("Interface\\AddOns\\RecountSkinByNth\\textures\\scroll_up_pushed")
	  _G[scrollbar:GetName().."ScrollUpButton"]:SetHighlightTexture("Interface\\AddOns\\RecountSkinByNth\\textures\\scroll_button_highlight")
	  
	  _G[scrollbar:GetName().."ScrollDownButton"]:SetHeight(height or 16)
	  _G[scrollbar:GetName().."ScrollDownButton"]:SetNormalTexture("Interface\\AddOns\\RecountSkinByNth\\textures\\scroll_down_normal")
	  _G[scrollbar:GetName().."ScrollDownButton"]:SetDisabledTexture("Interface\\AddOns\\RecountSkinByNth\\textures\\scroll_down_disabled")
	  _G[scrollbar:GetName().."ScrollDownButton"]:SetPushedTexture("Interface\\AddOns\\RecountSkinByNth\\textures\\scroll_down_pushed")
	  _G[scrollbar:GetName().."ScrollDownButton"]:SetHighlightTexture("Interface\\AddOns\\RecountSkinByNth\\textures\\scroll_button_highlight")
	  
	  local Rgns = { _G[scrollbar:GetName().."ScrollDownButton"]:GetRegions() };
	  for _, rgn in ipairs(Rgns) do if rgn:IsObjectType("texture") then rgn:SetVertexColor(1,1,1,1) end end--do
	  local Rgns = { _G[scrollbar:GetName().."ScrollUpButton"]:GetRegions() };
	  for _, rgn in ipairs(Rgns) do if rgn:IsObjectType("texture") then rgn:SetVertexColor(1,1,1,1) end end--do
end--function

function me:ResizeWindow(frame)
  frame.NumBars = floor((frame:GetHeight() - 32.95) / (Recount.db.profile.MainWindow.RowHeight + Recount.db.profile.MainWindow.RowSpacing))
  if not Recount.db.profile.MainWindow.HideTotalBar==true then frame.NumBars=frame.NumBars-1 end
  frame.ScrollFrame:SetHeight((frame.NumBars*(Recount.db.profile.MainWindow.RowHeight + Recount.db.profile.MainWindow.RowSpacing))-Recount.db.profile.MainWindow.RowSpacing)
  if not frame.Bars then frame.Bars={} end
  me:RefreshWindow(frame, FORCE)
  rs_saved["WindowSize"][frame:GetID()]={frame:GetWidth(), frame:GetHeight()}
end--function me:ResizeWindow(frame)

function me:SetMode(mode,target)
  if mode > #Recount.MainWindowData then mode=1 end
  if mode<1 then mode=table.maxn(Recount.MainWindowData) end
  if target and strlower(target)=="main" then
    Recount:SetMainWindowMode(mode)
  else
    rs_saved["Mode"][target]=mode
    me.Windows[target].Title:SetText(me.MainWindowData[mode][3])
	me:ResizeWindow(me.Windows[target])
	if Recount.DetailWindow:IsVisible() and Recount.DetailWindow.Hijacked then Recount:SetMainWindowMode(mode) end
  end
  me.SelectModeWindow:Hide()
  me.ReportWindow:Hide()
end--function me:SetMode(mode,target)

function me:RefreshWindow(frame,force)
	if not Recount.NewData and not force then return end
	ID=frame:GetID()
	if not IS_BARS_LOADED[ID] then return end
	frame.Data,frame.Highest,frame.Total,frame.TotalPerSec=me:GetData(rs_saved["Mode"][ID],ID)
	
	local ModeNameEnglish = me.MainWindowData[rs_saved["Mode"][ID]][1]
	for i=1,#frame.Data do frame.Data[i][5] = me:ReturnMergedAmount(ModeNameEnglish, frame.Data[i][1]) end
	
	local maxoffset=table.maxn(frame.Data)-frame.NumBars
	if maxoffset<0 then maxoffset=0 end
	
	frame.ScrollFrameScrollBar:SetMinMaxValues(0,maxoffset)
	frame.ScrollFrameScrollBar:SetValueStep(1)
	frame.Offset=floor(frame.ScrollFrameScrollBar:GetValue())
	
	if frame.Offset>table.maxn(frame.Data)-frame.NumBars then frame.Offset=table.maxn(frame.Data)-frame.NumBars end
	if frame.Offset<0 then frame.Offset=0 end
	if maxoffset==0 or not Recount.db.profile.MainWindow.ShowScrollbar then
	  Recount:HideScrollbarElements(frame.ScrollFrame:GetName())
	  frame.ScrollFrame:SetPoint("TOPRIGHT",-6,0)
	else
      if Recount.db.profile.MainWindow.ShowScrollbar then
		Recount:ShowScrollbarElements(frame.ScrollFrame:GetName())
		frame.ScrollFrame:SetPoint("TOPRIGHT",-26,0)
	  end
	end
	if maxoffset > floor(frame.NumBars/2) then frame.ScrollFrameScrollBar.scrollStep = floor(frame.NumBars/2) else frame.ScrollFrameScrollBar.scrollStep=1 end
	if table.maxn(frame.Bars)+frame.Offset < frame.NumBars then frame.NumBars=table.maxn(frame.Bars)+frame.Offset end
	for i=1,30 do frame.Bars[i]:Hide()end
	me:UpdateBarData(frame,0)
	for i = 1, frame.NumBars do
	  if frame.Data[i] then
		me:UpdateBarData(frame,i)
		frame.Bars[i]:Show()
      end--if
	end
end--function me:RefreshWindow(frame,FORCE)

function me:ReturnMergedAmount(ModeNameEnglish,WholeName)
    if not WholeName then return 0,0 end
	local Merged=0
	local Full=0
	if ModeNameEnglish=="Healing Done" and Recount.db.profile.MergeAbsorbs then
      Merged = Recount.db2.combatants[WholeName].Fights[Recount.db.profile.CurDataSet].Absorbs or 0
	  Full = (Recount.db2.combatants[WholeName].Fights[Recount.db.profile.CurDataSet].Healing or 0) + (Recount.db2.combatants[WholeName].Fights[Recount.db.profile.CurDataSet].Absorbs or 0)
	elseif ModeNameEnglish=="Damage Done" and Recount.db.profile.MergePets then
	  local damage, dps = Recount:MergedPetDamageDPS(Recount.db2.combatants[WholeName], Recount.db.profile.CurDataSet) 
	  Merged = damage - (Recount.db2.combatants[WholeName].Fights[Recount.db.profile.CurDataSet].Damage or 0)
	  Full = damage
	end
	return Merged,Full
end--me:ReturnMergedAmount(ModeNameEnglish,WholeName)

function me:UpdateBarData(frame,i)
	local iBar = i
	local iData = i + frame.Offset
	local lefttext
      if iBar==0 then lefttext=L["Total"] else lefttext=frame.Data[iData][1] or "" end
	  if not Recount.db.profile.MainWindow.BarText.ServerName then lefttext = string.gsub(lefttext, "%-[^ >]+", "") end
	local righttext
	  if iBar==0 then righttext=frame.Total else righttext=frame.Data[iData][3] or 0 end
	  if iBar==0 then frame.Bars[iBar]["Value"]=frame.Highest else frame.Bars[iBar]["Value"]=tonumber(righttext) end
    local percent=(righttext/frame.Total)*100
	  righttext=Recount:FormatLongNums(righttext)
    local PerSec
	  if iBar==0 then
	    PerSec = frame.TotalPerSec and Recount:FormatLongNums(frame.TotalPerSec) or ""
	  else
	    PerSec = frame.Data[iData][4] and Recount:FormatLongNums(frame.Data[iData][4]) or ""
	  end 
	local barColor
	  if iBar==0 then barColor=Recount.Colors:GetColor("Bar","Total Bar") else barColor=Recount.Colors:GetColor("Class",frame.Data[iData][2]) end
	local textColor=Recount.Colors:GetColor("Bar","Bar Text")
      if Recount.db.profile.MainWindow.BarText.PerSec and PerSec ~= "" then
		righttext = string.format("%s (%s", righttext, PerSec)
	    if Recount.db.profile.MainWindow.BarText.Percent then righttext = string.format("%s, %.1f%%)", righttext, percent) else righttext = righttext .. ")" end
	  elseif Recount.db.profile.MainWindow.BarText.Percent then
	    righttext = string.format("%s (%.1f%%)", righttext, percent)
	  end
	if iBar~=0 then
	  frame.Bars[iBar]["WholeName"] = frame.Data[iData][1] or ""
	  frame.Bars[iBar]["ClassColor"]= Recount.Colors:GetColor("Class",frame.Data[iData][2])
	  frame.Bars[iBar]["Merged"] = frame.Data[iData][5] or 0
	else
	  frame.Bars[iBar]["Merged"] = 0
	end
	frame.Bars[iBar]["DataTextLeft"] =lefttext
	frame.Bars[iBar]["DataTextRight"]=righttext
	frame.Bars[iBar]["DataBarColor"] =barColor
    frame.Bars[iBar]["DataTextColor"]=textColor
end--me:UpdateBarData(frame,i)

function me:BarUpdate(self,elapsed,frameID)
  if not IS_BARS_LOADED[frameID] then return end
    local frame=self:GetParent()
	if not frame.Data then return end
	
	if self:GetID()==0 then
	  self.TextLeft:SetText( Recount.db.profile.MainWindow.BarText.RankNum and "0. "..self.DataTextLeft or self.DataTextLeft )
	else
	  self.TextLeft:SetText( Recount.db.profile.MainWindow.BarText.RankNum and self:GetID()+frame.Offset..". "..self.DataTextLeft or self.DataTextLeft )
	end

	self.TextRight:SetText(self.DataTextRight)
	self.BarTexture:SetWidth(self:GetWidth()*(self.Value/frame.Highest))
	self.BarTexture:SetTexture(RecountSkin.BarTexture)
  --Merged	
	if not(rs_saved["usemergedoverlay"]) and self.Merged and self.Merged>0 then
	  local MergedPercent = self.Merged / self.Value
	  self.MergedTexture:SetWidth((self:GetWidth()*(self.Value/frame.Highest))*MergedPercent)
	else
	  self.MergedTexture:SetWidth(0.000001)
	end
  --Colors
	if not Recount.db.profile.BarTextColorSwap then
	  self.BarTexture:SetVertexColor(self.DataBarColor.r, self.DataBarColor.g, self.DataBarColor.b, frame.BarAlpha or self.DataBarColor.a)
	  self.TextRight:SetTextColor(self.DataTextColor.r, self.DataTextColor.g, self.DataTextColor.b, self.DataTextColor.a)
	  self.TextLeft:SetTextColor(self.DataTextColor.r, self.DataTextColor.g, self.DataTextColor.b, self.DataTextColor.a)
	else
	  self.BarTexture:SetVertexColor(self.DataTextColor.r, self.DataTextColor.g, self.DataTextColor.b, frame.BarAlpha or self.DataTextColor.a)
	  self.TextRight:SetTextColor(self.DataBarColor.r, self.DataBarColor.g, self.DataBarColor.b, self.DataBarColor.a)
	  self.TextLeft:SetTextColor(self.DataBarColor.r, self.DataBarColor.g, self.DataBarColor.b, self.DataBarColor.a)
	end
end--me:BarUpdate(self,elapsed,frameID)

me.IncludeTable={["DRUID"]=1,["PRIEST"]=1,["WARRIOR"]=1,["WARLOCK"]=1,["SHAMAN"]=1,["HUNTER"]=1,["ROGUE"]=1,["PALADIN"]=1,["DEATHKNIGHT"]=1, ["MAGE"]=1, ["MONK"]=1, ["PET"]=1}

function me:GetData(dataMode,ID)
  if Recount.db.profile.MergePets then me.IncludeTable.PET=nil else me.IncludeTable.PET=1 end
  local data=Recount.db2.combatants
  local Total,Highest,TotalPerSec=0,0
  local refTable={}
    for k,v in pairs(data) do
      if me.IncludeTable[data[k].enClass] then
	    if type(data[k])=="table" then
		  local tmpValue,Value2=me:ReturnValue(data,k,dataMode,ID)
		  if tmpValue>=1 then
	        tinsert(refTable,1,{k, data[k].enClass, tmpValue, Value2})
		    Total=Total+tmpValue
			if Value2 then TotalPerSec=(TotalPerSec or 0) + Value2 end
		    if tmpValue>Highest then Highest=tmpValue end
		  end--if
	    end--if
	  end--if Include
	end--do
	sort(refTable, function(a,b) if a[3]~=b[3] then return a[3]>b[3] else if a[1]:lower()~=b[1]:lower() then return a[1]:lower()<b[1]:lower() end end end)
  return refTable,Highest+0.0000001,Total or 0,TotalPerSec or nil
end--function

function me:ReturnValue(data,k,dataMode,ID)
  if not data then return 0 end
  if not data[k] then return 0 end
  if not data[k].Fights then return 0 end
  if not Recount.db.profile.CurDataSet then return 0 end
  if not data[k].Fights[Recount.db.profile.CurDataSet] then return 0 end
  local value,value2
  if not me.MainWindowData then dataMode=1 else dataMode=me.MainWindowData[rs_saved["Mode"][ID]][2] end
  
      if dataMode==1 then			--Damage Done
	      --Settings Apply
	        value,value2=Recount:MergedPetDamageDPS(data[k],Recount.db.profile.CurDataSet)
		    value2=math.floor(value2)
	    elseif dataMode==2 then		--DPS
		  --Settings Apply
	        _,value=Recount:MergedPetDamageDPS(data[k],Recount.db.profile.CurDataSet)
		    value=math.floor(value)
		elseif dataMode==3 then		--FriendlyFire
		  value=data[k].Fights[Recount.db.profile.CurDataSet].FDamage or 0
	    elseif dataMode==4 then		--DamageTaken
	      value=data[k].Fights[Recount.db.profile.CurDataSet].DamageTaken or 0
	    elseif dataMode==5 then		--Healing Done
		  --Settings Apply
	        value,value2=Recount:MergedPetHealingDPS(data[k],Recount.db.profile.CurDataSet)
		    value2=math.floor(value2)
        elseif dataMode==6 then		--Absorbs
	      value=data[k].Fights[Recount.db.profile.CurDataSet].Absorbs or 0
        elseif dataMode==7 then		
	      value=data[k].Fights[Recount.db.profile.CurDataSet].HealingTaken or 0
	    elseif dataMode==8 then
	      value=data[k].Fights[Recount.db.profile.CurDataSet].Overhealing or 0
	    elseif dataMode==9 then
	      value=data[k].Fights[Recount.db.profile.CurDataSet].DeathCount or 0
	    elseif dataMode==10 then
	      value=data[k].Fights[Recount.db.profile.CurDataSet].DOT_Time or 0
	    elseif dataMode==11 then
	      value=data[k].Fights[Recount.db.profile.CurDataSet].HOT_Time or 0
	    elseif dataMode==12 then
	      value=math.floor(data[k].Fights[Recount.db.profile.CurDataSet].ActiveTime or 0)
	    elseif dataMode==13 then
	      value=data[k].Fights[Recount.db.profile.CurDataSet].Dispels or 0
	    elseif dataMode==14 then
	      value=data[k].Fights[Recount.db.profile.CurDataSet].Dispelled or 0
	    elseif dataMode==15 then
	      value=data[k].Fights[Recount.db.profile.CurDataSet].Interrupts or 0
	    elseif dataMode==16 then
	      value=data[k].Fights[Recount.db.profile.CurDataSet].Ressed or 0
	    elseif dataMode==17 then
          value=data[k].Fights[Recount.db.profile.CurDataSet].CCBreak or 0
		elseif dataMode==18 then --Mana Gained
          value=data[k].Fights[Recount.db.profile.CurDataSet].ManaGain or 0
		elseif dataMode==19 then --Energy Gained
          value=data[k].Fights[Recount.db.profile.CurDataSet].EnergyGain or 0
		elseif dataMode==20 then --Rage Gained
          value=data[k].Fights[Recount.db.profile.CurDataSet].RageGain or 0
	    elseif dataMode==21 then --Runic Power Gained
          value=data[k].Fights[Recount.db.profile.CurDataSet].RunicPowerGain or 0
		end--if dataMode
	if value2 and value2<1 then value2=nil end
    return value or 0, value2
end--function	
	
function me:ArrangeMainWindowData()
      me.MainWindowData={}
      for i=1,#Recount.MainWindowData do
	  if Recount.MainWindowData[i] then
        if Recount.MainWindowData[i][1]==L["Damage Done"] 			then me.MainWindowData[i]={[1]="Damage Done",			[2]= 1, [3]=L["Damage Done"]} end
		if Recount.MainWindowData[i][1]==L["DPS"] 					then me.MainWindowData[i]={[1]="DPS",					[2]= 2, [3]=L["DPS"]} end
		if Recount.MainWindowData[i][1]==L["Friendly Fire"] 		then me.MainWindowData[i]={[1]="Friendly Fire",			[2]= 3, [3]=L["Friendly Fire"]} end
		if Recount.MainWindowData[i][1]==L["Damage Taken"] 			then me.MainWindowData[i]={[1]="Damage Taken",			[2]= 4, [3]=L["Damage Taken"]} end
		if Recount.MainWindowData[i][1]==L["Healing Done"] 			then me.MainWindowData[i]={[1]="Healing Done",			[2]= 5, [3]=L["Healing Done"]} end
		if Recount.MainWindowData[i][1]==L["Absorbs"] 				then me.MainWindowData[i]={[1]="Absorbs",				[2]= 6, [3]=L["Absorbs"]} end
		if Recount.MainWindowData[i][1]==L["Healing Taken"] 		then me.MainWindowData[i]={[1]="Healing Taken",			[2]= 7, [3]=L["Healing Taken"]} end
		if Recount.MainWindowData[i][1]==L["Overhealing Done"]		then me.MainWindowData[i]={[1]="Overhealing Done",		[2]= 8, [3]=L["Overhealing Done"]} end
		if Recount.MainWindowData[i][1]==L["Deaths"] 				then me.MainWindowData[i]={[1]="Deaths",				[2]= 9, [3]=L["Deaths"]} end
		if Recount.MainWindowData[i][1]==L["DOT Uptime"] 			then me.MainWindowData[i]={[1]="DOT Uptime",			[2]= 10,[3]=L["DOT Uptime"]} end
		if Recount.MainWindowData[i][1]==L["HOT Uptime"] 			then me.MainWindowData[i]={[1]="HOT Uptime",			[2]= 11,[3]=L["HOT Uptime"]} end
		if Recount.MainWindowData[i][1]==L["Activity"] 				then me.MainWindowData[i]={[1]="Activity",				[2]= 12,[3]=L["Activity"]} end
		if Recount.MainWindowData[i][1]==L["Dispels"] 				then me.MainWindowData[i]={[1]="Dispels",				[2]= 13,[3]=L["Dispels"]} end
		if Recount.MainWindowData[i][1]==L["Dispelled"] 			then me.MainWindowData[i]={[1]="Dispelled",				[2]= 14,[3]=L["Dispelled"]} end
		if Recount.MainWindowData[i][1]==L["Interrupts"] 			then me.MainWindowData[i]={[1]="Interrupts",			[2]= 15,[3]=L["Interrupts"]} end
		if Recount.MainWindowData[i][1]==L["Ressers"] 				then me.MainWindowData[i]={[1]="Ressers",				[2]= 16,[3]=L["Ressers"]} end
		if Recount.MainWindowData[i][1]==L["CC Breakers"] 			then me.MainWindowData[i]={[1]="CC Breakers",			[2]= 17,[3]=L["CC Breakers"]} end
		if Recount.MainWindowData[i][1]==L["Mana Gained"] 			then me.MainWindowData[i]={[1]="Mana Gained",			[2]= 18,[3]=L["Mana Gained"]} end
		if Recount.MainWindowData[i][1]==L["Energy Gained"] 		then me.MainWindowData[i]={[1]="Energy Gained",			[2]= 19,[3]=L["Energy Gained"]} end
		if Recount.MainWindowData[i][1]==L["Rage Gained"] 			then me.MainWindowData[i]={[1]="Rage Gained",			[2]= 20,[3]=L["Rage Gained"]} end
		if Recount.MainWindowData[i][1]==L["Runic Power Gained"]	then me.MainWindowData[i]={[1]="Runic Power Gained",	[2]= 21,[3]=L["Runic Power Gained"]} end
		if Recount.MainWindowData[i][1]==L["Astral Power Gained"]	then me.MainWindowData[i]={[1]="Astral Power Gained",	[2]= 22,[3]=L["Astral Power Gained"]} end
		if Recount.MainWindowData[i][1]==L["Maelstorm Gained"]		then me.MainWindowData[i]={[1]="Maelstorm Gained",		[2]= 23,[3]=L["Maelstorm Gained"]} end
		if Recount.MainWindowData[i][1]==L["Fury Gained"]			then me.MainWindowData[i]={[1]="Fury Gained",			[2]= 24,[3]=L["Fury Gained"]} end
		if Recount.MainWindowData[i][1]==L["Pain Gained"]			then me.MainWindowData[i]={[1]="Pain Gained",			[2]= 25,[3]=L["Pain Gained"]} end
	  end--if
	  end--do
end--function	

function me:SetColorToIcon(icon,r,g,b,window)
   local theFrame
   if not window then theFrame=Recount.MainWindow[icon] else theFrame=me.Windows[window][icon] end
    local Regions = {theFrame:GetRegions()}
    for i,Region in pairs(Regions) do
	  if i==1 then Region:SetVertexColor(r,g,b,1) end
	end--do
end--function

function me:ChangeRecountControlTextures(button, texture, skipp)
  local Regions = {button:GetRegions()}
    for i,Region in pairs(Regions) do
	  if i==1 then Region:SetTexture("Interface\\AddOns\\RecountSkinByNth\\textures\\"..texture.."_normal")end
	  if i==2 then Region:SetTexture("Interface\\AddOns\\RecountSkinByNth\\textures\\"..texture.."_normal")end
	  if i==3 then Region:SetTexture("Interface\\AddOns\\RecountSkinByNth\\textures\\"..texture.."_normal") end
	end--do
  if skipp then return end
  button:SetHeight(16)
  button:SetScript("OnLeave", function() me:ShowTip() end)
end--function

function me:ShowTip(self,tip,ismod)
  if not self or (rs_saved["killtooltip"] and not(ismod and not rs_saved["killmodtooltip"])) then
    me.Tooltip:Hide()
    me.Tooltip.scale=me.Tooltip.part
	me.Tooltip:SetScale(me.Tooltip.part)
	me.Tooltip.elapsed=0
    return
  end
  GameTooltip:Hide()
    me.Tooltip:SetScale(1)
    me.Tooltip:SetPoint("BOTTOM",self,"TOP",0,0)
    me.Tooltip.Text:SetText(tip)
    me.Tooltip:SetWidth(me.Tooltip.Text:GetWidth()+34)
	me.Tooltip:SetHeight(me.Tooltip.Text:GetHeight()+26)
	me.Tooltip:SetScale(me.Tooltip.scale)
    me.Tooltip:Show()
end--function

me.ModeTooltipConversionTable={
	["Damage Done"]     	= {L["Damage Abilities"], "Attacks", L["Attacked"], "DamagedWho"},
	["DPS"]             	= {L["Damage Abilities"], "Attacks", L["Attacked"], "DamagedWho"},
	["Friendly Fire"]   	= {L["Friendly Attacks"], "FAttacks", L["Attacked"], "FDamagedWho"},
	["Damage Taken"]    	= {L["Attacked by"], "WhoDamaged"},
	["Healing Done"]    	= {L["Heals"], "Heals", L["Healed"], "HealedWho"},
	["Absorbs"]         	= {L["Absorbs"], "Absorbed", L["Shielded"], "ShieldedWho"},
	["Healing Taken"]   	= {L["Healed By"], "WhoHealed"},
	["Overhealing Done"]	= {L["Over Heals"], "OverHeals"},
	["Deaths"]          	= {},
	["DOT Uptime"]      	= {L["DOTs"], "DOTs"},
	["HOT Uptime"]      	= {L["HOTs"], "HOTs"},
	["Activity"]			= {L["Attacked/Healed"], "TimeSpent"},
	["Dispels"]				= {L["Dispelled"], "DispelledWho"},
	["Dispelled"]			= {L["Dispelled By"], "WhoDispelled"},
	["Interrupts"]			= {L["Interrupted"], "InterruptData"},
	["Ressers"]				= {L["Ressed"], "RessedWho"},
	["CC Breakers"]			= {L["CC's Broken"], "CCBroken"},
	["Mana Gained"]			= {L["Mana Abilities"], "ManaGained", L["Mana Sources"], "ManaGainedFrom"},
	["Energy Gained"]		= {L["Energy Abilities"], "EnergyGained", L["Energy Sources"], "EnergyGainedFrom"},
	["Rage Gained"]			= {L["Rage Abilities"], "RageGained", L["Rage Sources"], "RageGainedFrom"},
	["Runic Power Gained"]	={L["Runic Power Abilities"], "RunicPowerGained", L["Runic Power Sources"], "RunicPowerGainedFrom"},
	["Astral Power Gained"]	={L["Astral Power Abilities"], "AstralPowerGained", L["Astral Power Sources"], "AstralPowerGainedFrom"},
	["Maelstorm Gained"]	={L["Maelstorm Abilities"], "MaelstormGained", L["Maelstorm Sources"], "MaelstormGainedFrom"},
	["Fury Gained"]			={L["Fury Abilities"], "FuryGained", L["Fury Sources"], "FuryGainedFrom"},
	["Pain Gained"]			={L["Pain Abilities"], "PainGained", L["Pain Sources"], "PainGainedFrom"},
}
me.ModesWithPetData={
    ["Damage Done"]     = {L["Pet Damage Abilities"], "Attacks", L["Pet Attacked"], "DamagedWho"},
    ["DPS"]             = {L["Pet Damage Abilities"], "Attacks", L["Pet Attacked"], "DamagedWho"},
    ["Healing Done"]    = {L["Pet Healing Abilities"],"Heals", L["Pet Healed"], "HealedWho"}
}

function me:ShowCombatDetails(self,isRecountWindow)  
  if isRecountWindow then
    if not self or self.id==0 then me.DetailsTooltip:Hide(); return end
  else
    if not self or self:GetID()==0 then me.DetailsTooltip:Hide(); return end
  end
--GetMode
  local ModeIndex,WholeName,extraHeight,mergebarHeight
  if isRecountWindow then
    ModeIndex=Recount.db.profile.MainWindowMode
	WholeName=self.name
	extraHeight=14
	if Recount.db.profile.BarTextColorSwap then
	  local r,g,b,a=self.LeftText:GetTextColor()
	  self.ClassColor={["r"]=r,["g"]=g,["b"]=b,["a"]=a}
	  local r,g,b,a = self.StatusBar:GetStatusBarColor()
	  self.DataTextColor={["r"]=r,["g"]=g,["b"]=b,["a"]=a}
	else
	  local r,g,b,a = self.StatusBar:GetStatusBarColor()
	  self.ClassColor={["r"]=r,["g"]=g,["b"]=b,["a"]=a}
	  local r,g,b,a=self.LeftText:GetTextColor()
	  self.DataTextColor={["r"]=r,["g"]=g,["b"]=b,["a"]=a}
	end
  else
    ModeIndex=rs_saved.Mode[self:GetParent():GetID()]
	WholeName=self.WholeName
	extraHeight=14
  end
--Return if Data is not available
  if not me.ModeTooltipConversionTable[me.MainWindowData[ModeIndex][1]] then return end
  local ModeNameEnglish = me.MainWindowData[ModeIndex][1]
--Reset the Text Strings..
  for i=1,19 do
    me.DetailsTooltip.Left[i]:SetText("")
	me.DetailsTooltip.Right[i]:SetText("")
  end
--Anchor the Tooltip
   me.DetailsTooltip:SetPoint("BOTTOMRIGHT",self,"TOPRIGHT",8,-8)
--Insert the name
  me.DetailsTooltip.Left[1]:SetText(WholeName); me.DetailsTooltip.Right[1]:SetText(" ")
  me.DetailsTooltip.Left[1]:SetTextColor(self.ClassColor.r,self.ClassColor.g,self.ClassColor.b,self.ClassColor.a)
--Get the data table
  local data = Recount.db2.combatants[WholeName]
  local dbCombatants = Recount.db2.combatants
  local db = me.ModeTooltipConversionTable[me.MainWindowData[ModeIndex][1]]
  local section1, section2, section3, section4
  
  if db[1] then
    me.DetailsTooltip.Left[2]:SetText(L["Top 3"].." "..db[1]); me.DetailsTooltip.Right[2]:SetText(" ")
    section1 = me:GetSorted(data and data.Fights[Recount.db.profile.CurDataSet] and data.Fights[Recount.db.profile.CurDataSet][ db[2] ])
    for i,tbl in ipairs(section1) do
      me.DetailsTooltip.Left[2+i]:SetText(section1[i][1])
	  me.DetailsTooltip.Right[2+i]:SetText(section1[i][2])
    end
	if ModeNameEnglish=="Activity" then
	  local Heal, Damage
	  Heal = data and data.Fights[Recount.db.profile.CurDataSet].TimeHeal or 0
	  Damage = data and data.Fights[Recount.db.profile.CurDataSet].TimeDamage or 0
	  local prefix1,prefix2
	  local Total = Heal + Damage + 0.000001
	  Heal = 100 * Heal / Total
	  Damage = 100 * Damage / Total
	  if Heal>Damage then prefix1="|cff888888"; prefix2="|cff00ff00" else prefix1="|cff00ff00"; prefix2="|cff888888"  end --ffdd00
	  me.DetailsTooltip.Left[6]:SetText(prefix1..L["Time Damaging"]..":|r"); me.DetailsTooltip.Right[6]:SetText(prefix1..math.floor(Damage + 0.5).."%|r")
	  me.DetailsTooltip.Left[7]:SetText(prefix2..L["Time Healing"]..":|r"); me.DetailsTooltip.Right[7]:SetText(prefix2..math.floor(Heal + 0.5).."%|r")
	end
  end
  if db[3] then
    me.DetailsTooltip.Left[6]:SetText(L["Top 3"].." "..db[3]); me.DetailsTooltip.Right[6]:SetText(" ")
    section2 = me:GetSorted(data and data.Fights[Recount.db.profile.CurDataSet] and data.Fights[Recount.db.profile.CurDataSet][ db[4] ])
    for i,val in ipairs(section2) do
      me.DetailsTooltip.Left[6+i]:SetText(section2[i][1])
	  me.DetailsTooltip.Right[6+i]:SetText(section2[i][2])
    end
  end
  if Recount.db.profile.MergePets and data.Pet and me.ModesWithPetData[ModeNameEnglish] then
    db = me.ModesWithPetData[me.MainWindowData[ModeIndex][1]]
	local petindex = #data.Pet
	local Damage
    while not Damage and petindex > 0 do
	  if ModeNameEnglish=="Healing Done" then
	  	Damage = data.Pet[petindex] and dbCombatants[data.Pet[petindex]] and dbCombatants[data.Pet[petindex]] and dbCombatants[data.Pet[petindex]].Fights and dbCombatants[data.Pet[petindex]].Fights[Recount.db.profile.CurDataSet] and dbCombatants[data.Pet[petindex]].Fights[Recount.db.profile.CurDataSet].Healing
	  else
	    Damage = data.Pet[petindex] and dbCombatants[data.Pet[petindex]] and dbCombatants[data.Pet[petindex]] and dbCombatants[data.Pet[petindex]].Fights and dbCombatants[data.Pet[petindex]].Fights[Recount.db.profile.CurDataSet] and dbCombatants[data.Pet[petindex]].Fights[Recount.db.profile.CurDataSet].Damage
	  end
	  petindex = petindex - 1
	end
	petindex = petindex + 1
    if Damage and Damage ~= 0 then
	  if ModeNameEnglish=="Healing Done" then
	    Damage = Damage / (Damage + (data.Fights[Recount.db.profile.CurDataSet].Healing or 0))
	  else
	    Damage = Damage / (Damage + (data.Fights[Recount.db.profile.CurDataSet].Damage or 0))
	  end
	  local petName=string.gsub(data.Pet[petindex], "%s<[^ >]+%-?[^ >]+>", "")
		me.DetailsTooltip.Left[10]:SetText("|cffffdd00"..L["Pet"]..":|r "..petName); me.DetailsTooltip.Right[10]:SetText("("..math.floor(Damage * 100 + 0.5).."%)")
		me.DetailsTooltip.Left[10]:SetTextColor(self.ClassColor.r,self.ClassColor.g,self.ClassColor.b,self.ClassColor.a)
		me.DetailsTooltip.Left[11]:SetText(L["Top 3"].." "..db[1]); me.DetailsTooltip.Right[11]:SetText(" ")
		section3=me:GetSorted(dbCombatants[data.Pet[petindex] ].Fights and dbCombatants[data.Pet[petindex] ].Fights[Recount.db.profile.CurDataSet][ db[2] ])
		for i,val in ipairs(section3) do
          me.DetailsTooltip.Left[11+i]:SetText(section3[i][1])
	      me.DetailsTooltip.Right[11+i]:SetText(section3[i][2])
        end
		me.DetailsTooltip.Left[15]:SetText(L["Top 3"].." "..db[3]); me.DetailsTooltip.Right[15]:SetText("")
		section4=me:GetSorted(dbCombatants[data.Pet[petindex] ].Fights and dbCombatants[data.Pet[petindex] ].Fights[Recount.db.profile.CurDataSet][ db[4] ])
	    for i,val in ipairs(section4) do
          me.DetailsTooltip.Left[15+i]:SetText(section4[i][1])
	      me.DetailsTooltip.Right[15+i]:SetText(section4[i][2])
        end
	  end
  end
  --if not string.find(self:GetParent():GetName(),"RecountSkin_Window") then
    me.DetailsTooltip.Left[19]:SetText("|cff00ff00<"..L["Click for more Details"]..">|r"); me.DetailsTooltip.Right[19]:SetText(" ")
  --end
--Resize the Tooltip  
  local height = 16 + 16
  if section1 then height=height+6 end
  if section2 or ModeNameEnglish=="Activity" then height=height+6 end
  if section3 then height=height+6+6+6 end
  if section4 then height=height+6 end
  for i=1,18 do height=height+me.DetailsTooltip.Left[i]:GetHeight() end
  local width=0
  for i=1,18 do if me.DetailsTooltip.Left[i]:GetWidth() + me.DetailsTooltip.Right[i]:GetWidth() > width then width = me.DetailsTooltip.Left[i]:GetWidth() + me.DetailsTooltip.Right[i]:GetWidth() end end

  me.DetailsTooltip:SetWidth(16+20+16+width)
--MergeBars  
  --if not isRecountWindow and ((ModeNameEnglish=="Damage Done" and Recount.db.profile.MergePets) or (ModeNameEnglish=="Healing Done" and Recount.db.profile.MergeAbsorbs)) then
  if (ModeNameEnglish=="Damage Done" and Recount.db.profile.MergePets) or (ModeNameEnglish=="Healing Done" and Recount.db.profile.MergeAbsorbs) then
    me.DetailsTooltip.BarTexture:SetTexture(me.BarTexture)
	if Recount.db.profile.BarTextColorSwap then
	  me.DetailsTooltip.BarTexture:SetVertexColor(self.DataTextColor.r,self.DataTextColor.g,self.DataTextColor.b,self.DataTextColor.a)
	  me.DetailsTooltip.BarLeft:SetTextColor(self.ClassColor.r,self.ClassColor.g,self.ClassColor.b,self.ClassColor.a)
	  me.DetailsTooltip.BarRight:SetTextColor(self.ClassColor.r,self.ClassColor.g,self.ClassColor.b,self.ClassColor.a)
	else
      me.DetailsTooltip.BarTexture:SetVertexColor(self.ClassColor.r,self.ClassColor.g,self.ClassColor.b,self.ClassColor.a)
	  me.DetailsTooltip.BarLeft:SetTextColor(self.DataTextColor.r,self.DataTextColor.g,self.DataTextColor.b,self.DataTextColor.a)
	  me.DetailsTooltip.BarRight:SetTextColor(self.DataTextColor.r,self.DataTextColor.g,self.DataTextColor.b,self.DataTextColor.a)
	end
	me.DetailsTooltip.BarTexture:Show()
	me.DetailsTooltip.MergedTexture:SetWidth((me.DetailsTooltip.BarTexture:GetWidth()*(self.Merged / self.Value))+0.000001)
	if not(rs_saved["usemergedoverlay"] and rs_saved["usetooltipmergedoverlay"]) then me.DetailsTooltip.MergedTexture:Show() else me.DetailsTooltip.MergedTexture:Hide() end
	if ModeNameEnglish=="Damage Done" then
	  me.DetailsTooltip.BarLeft:SetText("Player")
	  if self.Merged>0 and not(rs_saved["usemergedoverlay"] and rs_saved["usetooltipmergedoverlay"]) then me.DetailsTooltip.BarRight:SetText("Pet ("..format("%0.1f",(self.Merged / self.Value)*100).."%)") else me.DetailsTooltip.BarRight:SetText() end
	else
	  if not(rs_saved["usemergedoverlay"] and rs_saved["usetooltipmergedoverlay"]) then me.DetailsTooltip.BarLeft:SetText("Heals") else me.DetailsTooltip.BarLeft:SetText("Player") end
	  if self.Merged>0 and not(rs_saved["usemergedoverlay"] and rs_saved["usetooltipmergedoverlay"]) then me.DetailsTooltip.BarRight:SetText("Absorbs ("..format("%0.1f",(self.Merged / self.Value)*100).."%)") else me.DetailsTooltip.BarRight:SetText() end
	end
	mergebarHeight=18
  else
    me.DetailsTooltip.BarTexture:Hide()
	me.DetailsTooltip.MergedTexture:Hide()
	me.DetailsTooltip.BarLeft:SetText("")
	me.DetailsTooltip.BarRight:SetText("")
	mergebarHeight=0
  end
  
  me.DetailsTooltip:SetSize(16+20+16+width, height + mergebarHeight + extraHeight)

--Show the Tooltip
  me.DetailsTooltip:Show()
end--function

local function Sort(a, b) if a[2] > b[2] then return true end return false end
me.tmptbl={}
function me:GetSorted(data,num)
    if not num then num=3 end
	local SortedData = Recount:GetTable()
	wipe(me.tmptbl)
	local total = 0.0000000001
	local i = 0
	if data then
		for k, v in pairs(data) do
			if v.amount then
				i = i + 1
				if not SortedData[i] then SortedData[i] = Recount:GetTable() end
				SortedData[i][1] = k
				SortedData[i][2] = v.amount
				total = total + v.amount
			end
		end
	end
	if num > i then num = i end
	table.sort(SortedData, Sort)
	local percent
	for i = 1, num do
		if SortedData[i] then
			if total ~= 0 then
				percent = math.floor(100 * SortedData[i][2] / total)
			else
				percent = 100
			end
			local name = SortedData[i][1]
			if not Recount.db.profile.MainWindow.BarText.ServerName then name = string.gsub(name, "%-[^ >]+", "") end
			tinsert(me.tmptbl,{"|cffffffff"..i..". "..name.."|r", "|cffffffff"..Recount:FormatLongNums(SortedData[i][2]).." ("..percent.."%)|r"})
		end
	end
	Recount:FreeTableRecurse(SortedData)
	return me.tmptbl
end--function

function me:SetReportSize(num)
	  for i=1,25 do
	    if i>num then
	      me.ReportWindow.Num[i].On:Hide()
		else
		  me.ReportWindow.Num[i].On:Show()
		end
	  end--do
	  rs_saved["ReportSize"]=num
	  if num<=5 then
	    me.ReportWindow.Title:SetText("Report size |cff00ff00"..num.."|r")
	  elseif num>5 and num<=10 then
	    me.ReportWindow.Title:SetText("Report size |cffaaff00"..num.."|r")
	  elseif num>10 and num<=15 then
	    me.ReportWindow.Title:SetText("Report size |cffffee00"..num.."|r")
	  elseif num>15 and num<=20 then
	    me.ReportWindow.Title:SetText("Report size |cffff9900"..num.."|r")
	  else
	    me.ReportWindow.Title:SetText("Report size |cffff0000"..num.."|r")
	  end
end--function

function me:ReportFuntion(targetFrame)
  if rs_saved["userecountreport"] then
    if targetFrame=="Main" then
	  --show recount report window
	  Recount:ShowReport("Main", Recount.ReportData)
	else
	  print(" ");
	  print("|cffffcc00Recount|rSkinByNth ->|cff888888 Reports can only be initiated from Recounts main window, change in Skin settings.");
	  print(" ")
    end
  else
    if me.ReportWindow:IsVisible() then
      me.ReportWindow:Hide()
    else
      me.ReportWindow.target=targetFrame;
	  me.ReportWindow:Show()
    end
  end
end--function

function me:InitiateReport(target,size,channel,unit)
    if target=="Main" then
	  Recount:ReportData(rs_saved["ReportSize"], channel, unit)
	else
	  local oldmode=Recount.db.profile.MainWindowMode
	  Recount:SetMainWindowMode(rs_saved["Mode"][me.ReportWindow.target])
	  Recount:ReportData(rs_saved["ReportSize"], channel, unit)
	  Recount:SetMainWindowMode(oldmode)
	end
	me.ReportWindow:Hide()
end--function

-- XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
-- XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
-- Create Frames

function me:CreateTooltip()
  me.Tooltip=CreateFrame("Frame",nil,UIParent)
  me.Tooltip:Hide()
  me.Tooltip:SetSize(100,34)
  me.Tooltip:SetPoint("BOTTOM",0,0)
  me.Tooltip:SetFrameStrata("TOOLTIP")
  me.Tooltip:SetClampedToScreen(true)
  me.Tooltip.Text = me.Tooltip:CreateFontString(nil,"ARTWORK")
  me.Tooltip.Text:SetFont("Interface\\AddOns\\RecountSkinByNth\\Skinned_Alive.ttf",10)
  me.Tooltip.Text:SetTextColor(0.8, 0.8, 0.8, 1)
  me.Tooltip.Text:SetPoint("CENTER",0,1)
  me.Tooltip.Text:SetJustifyH("LEFT")
  me:FixFrameBackdrop(me.Tooltip)
--"OnLoad"
  me.Tooltip.elapsed=0
  me.Tooltip.update=0.05
  me.Tooltip.part=0.25
  me.Tooltip.scale=0.25
--Scripts
  me.Tooltip:SetScript("OnUpdate", function(self,elapsed)
    self.elapsed=self.elapsed+elapsed
    if self.update>self.elapsed or self.scale>1 then return else self.elapsed=0 end
	  self.scale = self.scale + self.part
	  self:SetScale(self.scale)
  end)
end--function

function me:CreateFightsPopup()
  me.FightsPopup=CreateFrame("Frame","rs_FightsPopup",UIParent)
  me.FightsPopup:Hide()
  me.FightsPopup:SetSize(174,12+(2*18)+12)
  me:FixFrameBackdrop(me.FightsPopup)
  me.FightsPopup:SetClampedToScreen(true)
  me.FightsPopup:SetFrameStrata("TOOLTIP")
--Create Selection Buttons (same style as mode select)
  for i=1,7 do  --Overall, Current and 5 Fights
    me.FightsPopup[i]=CreateFrame("Frame","rs_FightsPopupButton"..i,me.FightsPopup)
	me.FightsPopup[i]:Hide()
	me.FightsPopup[i]:SetSize(150,18)
	me.FightsPopup:EnableMouse(true)
	me.FightsPopup[i]:SetPoint("TOPLEFT",12,-12-(i*18-18))
	me.FightsPopup[i]:SetPoint("RIGHT",-12,0)
	  me.FightsPopup[i].Focus=me.FightsPopup[i]:CreateTexture(nil,"BACKGROUND")
	  me.FightsPopup[i].Focus:SetColorTexture(1,1,1,0.15)
	  me.FightsPopup[i].Focus:SetAllPoints()
	me.FightsPopup[i].Icon=me.FightsPopup[i]:CreateTexture(nil,"OVERLAY")
	me.FightsPopup[i].Icon:SetSize(14,14)
	me.FightsPopup[i].Icon:SetPoint("CENTER",me.FightsPopup[i],"LEFT",14,0)
	  me.FightsPopup[i].Highlight=me.FightsPopup[i]:CreateTexture(nil,"HIGHLIGHT",nil,"ADD")
	  me.FightsPopup[i].Highlight:SetColorTexture(0,0.25,1,0.25)
	  me.FightsPopup[i].Highlight:SetAllPoints()
	me.FightsPopup[i].Text=me.FightsPopup[i]:CreateFontString(nil,"OVERLAY","GameFontNormal")
	--me.FightsPopup[i].Text:SetSize(120,16)
	me.FightsPopup[i].Text:SetPoint("LEFT",30,1)
	me.FightsPopup[i].Text:SetTextColor(1,1,1,1)
	me.FightsPopup[i].Text:SetJustifyH("LEFT")
	--me.FightsPopup[i].Text:SetNonSpaceWrap(false)
	me.FightsPopup[i]:SetID(i)
	me.FightsPopup[i]:SetScript("OnEnter",function(self) self.Icon:SetSize(24,24) end)
	me.FightsPopup[i]:SetScript("OnLeave",function(self) self.Icon:SetSize(14,14) end)
  end--do
  me.FightsPopup[1]:SetScript("OnMouseUp",function(self) me:SetRecountFightData("OverallData", "Overall Data") end)
  me.FightsPopup[1].Icon:SetTexture("Interface\\AddOns\\RecountSkinByNth\\textures\\fight_overall")
  me.FightsPopup[2]:SetScript("OnMouseUp",function(self) if Recount.InCombat then me:SetRecountFightData("CurrentFightData", "Current Fight") else me:SetRecountFightData("LastFightData", "Current Fight") end end)
  me.FightsPopup[2].Icon:SetTexture("Interface\\AddOns\\RecountSkinByNth\\textures\\fight_current")
--Scripts
  me.FightsPopup.update=5
  me.FightsPopup.elapsed=0
  me.FightsPopup:SetScript("OnUpdate",function(self,elapsed)
	self.elapsed=self.elapsed+elapsed
	if self.update>self.elapsed then return end
    if strsub(GetMouseFocus():GetName() or "",1,strlen(self:GetName()))==self:GetName() then self.elapsed=3 else self:Hide(); self.elapsed=0 end
  end)
  me.FightsPopup:SetScript("OnHide",function(self) self.elapsed=0 end)
  me.FightsPopup:SetScript("OnShow",function(self)
    local height=12+(2*18)+12
	local width=150
    for i=1,7 do me.FightsPopup[i].Focus:Hide(); me.FightsPopup[i]:Hide() end
    me.FightsPopup[1].Text:SetText(L["Overall Data"])
	if Recount.db.profile.CurDataSet == "OverallData" then me.FightsPopup[1].Focus:Show() end
	me.FightsPopup[1]:Show()
	me.FightsPopup[2].Text:SetText(L["Current Fight"])
	if Recount.db.profile.CurDataSet == "CurrentFightData" or Recount.db.profile.CurDataSet == "LastFightData" then me.FightsPopup[2].Focus:Show() end
	me.FightsPopup[2]:Show()
	local i=0
	for key,val in pairs(Recount.db2.FoughtWho) do
	--if val and val~="" then
	  i=i+1; height=height+18
	  if i==1 and val~=rs_saved.LastFight then rs_saved.LastFight=val; tinsert(rs_saved.TextureTable,1,rs_saved.TextureTable[6]); tremove(rs_saved.TextureTable,7) end
	    local name,h1,m1,s1,h2,m2,s2=strmatch(val,"^(.+)%s(%d+):(%d+):(%d+)-(%d+):(%d+):(%d+)$")
		if h1>h2 then h2=h2+24 end
	    local durationSec=((h2*60*60)+(m2*60)+s2)-((h1*60*60)+(m1*60)+s1)
	    local Mins=floor(durationSec/60)
	    local Secs=durationSec-(Mins*60)
	    print()
		me.FightsPopup[i+2].Text:SetText(name.." ("..( Mins>0 and Mins.."m " or "" )..( Secs>0 and Secs.."s" or "" )..") ")
	  --me.FightsPopup[i+2].Text:SetText(i..". "..val)
	  if 12 + 30 + me.FightsPopup[i+2].Text:GetWidth() + 12 > width then width = 12 + 30 + me.FightsPopup[i+2].Text:GetWidth() + 12 end
	  
	  if Recount.db.profile.CurDataSet == "Fight"..i then me.FightsPopup[i+2].Focus:Show() end
	  me.FightsPopup[i+2]:SetScript("OnMouseUp",function(self) me:SetRecountFightData("Fight"..key, val) end)
	  
	  me.FightsPopup[i+2].Icon:SetTexture("Interface\\AddOns\\RecountSkinByNth\\textures\\fight_"..rs_saved.TextureTable[i])
	  me.FightsPopup[i+2]:Show()
	--end--if
	end--do
	me.FightsPopup:SetSize(width,height)
  end)
end--function me:CreateFightsPopup()

function me:CreateSelectModeWindow()
  me.SelectModeWindow=CreateFrame("Frame","rs_SelectModeWindow",UIParent)
  me.SelectModeWindow:Hide()
  me.SelectModeWindow:SetSize(174,402)
  me:FixFrameBackdrop(me.SelectModeWindow)
  me.SelectModeWindow:SetClampedToScreen(true)
  me.SelectModeWindow:SetFrameStrata("TOOLTIP")
  me.SelectModeWindow.ToggleGained=CreateFrame("Frame",nil,me.SelectModeWindow)
  me.SelectModeWindow.ToggleGained:SetSize(16,16)
  me.SelectModeWindow.ToggleGained.Texture=me.SelectModeWindow.ToggleGained:CreateTexture(nil,"WARTWORK")
  me.SelectModeWindow.ToggleGained.Texture:SetAllPoints()
  me.SelectModeWindow.ToggleGained.Texture:SetTexture("Interface\\AddOns\\RecountSkinByNth\\textures\\arrow_down")
--Create Mode Buttons
  for i=1,40 do
    me.SelectModeWindow[i]=CreateFrame("Frame","rs_SelectModeWindowMode"..i,me.SelectModeWindow)
	me.SelectModeWindow[i]:Hide()
	me.SelectModeWindow[i]:SetSize(150,18)
	if i==1 then
	  me.SelectModeWindow[i]:SetPoint("TOPLEFT",12,-12-(i*18-18))
	else
      me.SelectModeWindow[i]:SetPoint("TOPLEFT",me.SelectModeWindow[i-1],"BOTTOMLEFT",0,0)
	end
	me.SelectModeWindow[i].Focus=me.SelectModeWindow[i]:CreateTexture(nil,"BACKGROUND")
	me.SelectModeWindow[i].Focus:SetColorTexture(1,1,1,0.15)
	me.SelectModeWindow[i].Focus:SetAllPoints()
	me.SelectModeWindow[i].Icon=me.SelectModeWindow[i]:CreateTexture(nil,"OVERLAY")
	me.SelectModeWindow[i].Icon:SetTexture("Interface\\AddOns\\RecountSkinByNth\\textures\\modeicons")
	me.SelectModeWindow[i].Icon:SetSize(14,14)
	me.SelectModeWindow[i].Icon:SetPoint("CENTER",me.SelectModeWindow[i],"LEFT",14,0)
	me.SelectModeWindow[i].Highlight=me.SelectModeWindow[i]:CreateTexture(nil,"HIGHLIGHT",nil,"ADD")
	me.SelectModeWindow[i].Highlight:SetColorTexture(0,0.25,1,0.25)
	me.SelectModeWindow[i].Highlight:SetAllPoints()
	me.SelectModeWindow[i].Text=me.SelectModeWindow[i]:CreateFontString(nil,"OVERLAY","GameFontNormal")
	me.SelectModeWindow[i].Text:SetSize(120,16)
	me.SelectModeWindow[i].Text:SetPoint("LEFT",30,1)
	me.SelectModeWindow[i].Text:SetTextColor(1,1,1,1)
	me.SelectModeWindow[i].Text:SetJustifyH("LEFT")
	Recount:AddFontString(me.SelectModeWindow[i].Text)
	me.SelectModeWindow[i]:SetID(i)
	me.SelectModeWindow[i]:SetScript("OnMouseUp",function(self)
	  if self.Text:GetText()~="Power Gains" then
	    me:SetMode(self:GetID(),self:GetParent().target)
	  else
	    me.SelectModeWindow:SetHeight(me.SelectModeWindow:GetHeight()+(7*18))
		me.SelectModeWindow.ToggleGained:Hide()
		local mg=me.SelectModeWindow.mg
		me.SelectModeWindow[mg].Text:SetText(L["Mana Gained"])
		for i=mg,mg+7 do
		  me.SelectModeWindow[i].Icon:Show()
		  me.SelectModeWindow[i].Text:SetPoint("LEFT",30,1)
		  me.SelectModeWindow[i]:SetScale(1)
		  me.SelectModeWindow[i]:Show()
		end
	  end
	end)
	me.SelectModeWindow[i]:SetScript("OnEnter",function(self) self.Icon:SetSize(24,24) end)
	me.SelectModeWindow[i]:SetScript("OnLeave",function(self) self.Icon:SetSize(14,14) end)
  end--do
--Scripts
  me.SelectModeWindow.update=5
  me.SelectModeWindow.elapsed=0
  me.SelectModeWindow:SetScript("OnShow",function(self)
    if self.target=="Main" then
	  self:SetPoint("TOPRIGHT", Recount.MainWindow.Title,"TOPLEFT",0,50)
	  self.focus=Recount.db.profile.MainWindowMode
	else
	  self:SetPoint("TOPRIGHT", me.Windows[self.target].Title,"TOPLEFT",0,50)
	  self.focus=rs_saved.Mode[self.target] or 1
	end
	for i=1,40 do
	  if me.SelectModeWindow[i] then
	    me.SelectModeWindow[i].Focus:Hide()
	    me.SelectModeWindow[i]:Hide()
		me.SelectModeWindow[i]:SetScale(0.000001)
	  end 
	end--do
	local visibleOnes=0
	for i = 1, #Recount.MainWindowData do
	  if not Recount.MainWindowData[i] then
	    me.SelectModeWindow[i]:Hide()
		me.SelectModeWindow[i]:SetScale(0.000001)
	  else
	    visibleOnes=visibleOnes+1
	    me.SelectModeWindow[i]:Show()
		me.SelectModeWindow[i]:SetScale(1)
		me.SelectModeWindow[i].Text:SetText(Recount.MainWindowData[i][1])
		local IconID=RecountSkin.MainWindowData[i][2]
		local leftCoord=(IconID-1)*(0.0625/2)
		local rightCoord=IconID*(0.0625/2)
		me.SelectModeWindow[i].Icon:SetTexCoord(leftCoord,rightCoord,0,1)
		if i==self.focus then me.SelectModeWindow[i].Focus:Show() end
		if Recount.MainWindowData[i][1]==L["Mana Gained"] then
		  me.SelectModeWindow.ToggleGained:SetPoint("RIGHT",me.SelectModeWindow[i],"RIGHT",0,0)
          me.SelectModeWindow.ToggleGained:Hide()
		  self.mg=i
		end
	  end	
	end--do
	if self.focus<self.mg or self.focus>self.mg+7 then
	  me.SelectModeWindow[self.mg].Text:SetPoint("LEFT",8,1)
	  me.SelectModeWindow[self.mg].Text:SetText("Power Gains")
	  me.SelectModeWindow[self.mg].Icon:Hide()
	  me.SelectModeWindow.ToggleGained:Show()
	  for i=self.mg+1, self.mg+7 do
	    me.SelectModeWindow[i]:Hide()
		me.SelectModeWindow[i]:SetScale(0.000001)
	  end--do
	  me.SelectModeWindow:SetHeight((visibleOnes-7)*18 + 24 + 3)
	else
	  me.SelectModeWindow:SetHeight(visibleOnes*18 + 24 + 3)
	end
	self.elapsed=0
  end)
  me.SelectModeWindow:SetScript("OnUpdate",function(self,elapsed)
	self.elapsed=self.elapsed+elapsed
	if self.update>self.elapsed then return end
    if strsub(GetMouseFocus():GetName() or "",1,strlen(self:GetName()))==self:GetName() then self.elapsed=3 else self:Hide(); self.elapsed=0 end
  end)

end--function

function me:CreateDetailsTooltip()
  me.DetailsTooltip=CreateFrame("Frame","rs_DetailsTooltip",UIParent)
  me.DetailsTooltip:Hide()
  me.DetailsTooltip:SetSize(250,150)
  me:FixFrameBackdrop(me.DetailsTooltip)
  me.DetailsTooltip:SetClampedToScreen(true)
  me.DetailsTooltip:SetFrameStrata("TOOLTIP")
  --Texts
  me.DetailsTooltip.Left={}
  me.DetailsTooltip.Right={}
  me.DetailsTooltip.Left[1]=me.DetailsTooltip:CreateFontString(nil,"ARTWORK")
  me.DetailsTooltip.Left[1]:SetPoint("TOPLEFT",16,-16)
  me.DetailsTooltip.Left[1]:SetFont("Interface\\AddOns\\RecountSkinByNth\\Skinned_Alive.ttf",14,"OUTLINE")
  me.DetailsTooltip.Right[1]=me.DetailsTooltip:CreateFontString(nil,"ARTWORK")
  me.DetailsTooltip.Right[1]:SetFont("Interface\\AddOns\\RecountSkinByNth\\Skinned_Alive.ttf",14,"OUTLINE")
  me.DetailsTooltip.Right[1]:SetPoint("TOPRIGHT",-16,-16)
  for i=2,19 do
    me.DetailsTooltip.Left[i]=me.DetailsTooltip:CreateFontString(nil,"ARTWORK","GameFontNormal")
    me.DetailsTooltip.Left[i]:SetPoint("TOPLEFT",me.DetailsTooltip.Left[i-1],"BOTTOMLEFT",0,0)
    me.DetailsTooltip.Right[i]=me.DetailsTooltip:CreateFontString(nil,"ARTWORK","GameFontNormal")
    me.DetailsTooltip.Right[i]:SetPoint("TOPRIGHT",me.DetailsTooltip.Right[i-1],"BOTTOMRIGHT",0,0)
  end--do
  
  me.DetailsTooltip.Left[2]:SetPoint("TOPLEFT",me.DetailsTooltip.Left[1],"BOTTOMLEFT",6,-6)
  me.DetailsTooltip.Right[2]:SetPoint("TOPRIGHT",me.DetailsTooltip.Right[1],"BOTTOMRIGHT",0,-6)
  me.DetailsTooltip.Left[6]:SetPoint("TOPLEFT",me.DetailsTooltip.Left[5],"BOTTOMLEFT",0,-6)
  me.DetailsTooltip.Right[6]:SetPoint("TOPRIGHT",me.DetailsTooltip.Right[5],"BOTTOMRIGHT",0,-6)
  
  me.DetailsTooltip.Left[10]:SetPoint("TOPLEFT",me.DetailsTooltip.Left[9],"BOTTOMLEFT",0,-6)
  me.DetailsTooltip.Right[10]:SetPoint("TOPRIGHT",me.DetailsTooltip.Right[9],"BOTTOMRIGHT",0,-6)
  me.DetailsTooltip.Left[11]:SetPoint("TOPLEFT",me.DetailsTooltip.Left[10],"BOTTOMLEFT",0,-6)
  me.DetailsTooltip.Right[11]:SetPoint("TOPRIGHT",me.DetailsTooltip.Right[10],"BOTTOMRIGHT",0,-6)
  
  me.DetailsTooltip.Left[15]:SetPoint("TOPLEFT",me.DetailsTooltip.Left[14],"BOTTOMLEFT",0,-6)
  me.DetailsTooltip.Right[15]:SetPoint("TOPRIGHT",me.DetailsTooltip.Right[14],"BOTTOMRIGHT",0,-6)
  
  me.DetailsTooltip.Left[19]:ClearAllPoints()
  me.DetailsTooltip.Right[19]:ClearAllPoints()
  me.DetailsTooltip.Left[19]:SetPoint("BOTTOM",0,16)
  me.DetailsTooltip.Right[19]:SetPoint("BOTTOM",0,16)
  
  me.DetailsTooltip.BarTexture=me.DetailsTooltip:CreateTexture(nil,"ARTWORK")
  me.DetailsTooltip.BarTexture:SetPoint("BOTTOM",me.DetailsTooltip.Left[19],"TOP",0,4)
  me.DetailsTooltip.BarTexture:SetPoint("LEFT",16,0); me.DetailsTooltip.BarTexture:SetPoint("RIGHT",-16,0)
  me.DetailsTooltip.BarTexture:SetHeight(13)
    me.DetailsTooltip.MergedTexture=me.DetailsTooltip:CreateTexture(nil,"OVERLAY")
    me.DetailsTooltip.MergedTexture:SetPoint("TOPRIGHT",me.DetailsTooltip.BarTexture,"TOPRIGHT")
	me.DetailsTooltip.MergedTexture:SetPoint("BOTTOMRIGHT",me.DetailsTooltip.BarTexture,"BOTTOMRIGHT")
	me.DetailsTooltip.MergedTexture:SetWidth(0.000001)
	me.DetailsTooltip.MergedTexture:SetColorTexture(1,1,1,1)
	me.DetailsTooltip.MergedTexture:SetGradientAlpha("HORIZONTAL", 0, 0, 0, 0.25, 0, 0, 0, 0)
	  me.DetailsTooltip.BarLeft=me.DetailsTooltip:CreateFontString(nil,"OVERLAY")
	  me.DetailsTooltip.BarLeft:SetFont("Interface\\AddOns\\RecountSkinByNth\\Skinned_Alive.ttf",10)
	  me.DetailsTooltip.BarLeft:SetPoint("LEFT",me.DetailsTooltip.BarTexture,"LEFT",5,0)
	  me.DetailsTooltip.BarRight=me.DetailsTooltip:CreateFontString(nil,"OVERLAY")
	  me.DetailsTooltip.BarRight:SetFont("Interface\\AddOns\\RecountSkinByNth\\Skinned_Alive.ttf",10)
	  me.DetailsTooltip.BarRight:SetPoint("RIGHT",me.DetailsTooltip.BarTexture,"RIGHT",-5,0)

  --Skipp this..
  --for i=1,19 do
    --Recount:AddFontString(me.DetailsTooltip.Left[i])
	--Recount:AddFontString(me.DetailsTooltip.Right[i])
  --end
end--function me:CreateDetailsTooltip()

local repWinButtons={"SayButton","PartyButton","InstanceButton","RaidButton","GuildButton","OfficerButton","RealIDButton","WhisperButton","WhisperTargetButton"}
local repWinSmallButtons={"Channel1Button","Channel2Button","Channel3Button","Channel4Button"}
local channels={[1]=0,[2]=0,[3]=0,[4]=0}

function me:CreateReportWindow()
  me.ReportWindow=CreateFrame("Frame","rs_ReportWindow",UIParent)
  local frame=me.ReportWindow
  frame:Hide()
  frame:SetSize(174,312)
  frame:SetPoint("TOPRIGHT",0,0)
  frame:SetFrameStrata("HIGH")
  frame:SetClampedToScreen(true)
  frame:EnableMouse(true)
--Background
  me:FixFrameBackdrop(frame)
--Title
  frame.Title=frame:CreateFontString(nil,"ARTWORK","GameFontNormal")
    frame.Title:SetPoint("TOPLEFT",15,-15)
	frame.Title:SetText("Title")
	frame.Title:SetTextColor(1,1,1,1)
    Recount:AddFontString(frame.Title)
--Buttons
  frame.ExitButton=CreateFrame("Button","rs_ReportWindowExitButton",frame)
    frame.ExitButton:SetSize(16,16)
	frame.ExitButton:SetNormalTexture(me.texPath.."exit_normal")
	frame.ExitButton:SetHighlightTexture(me.texPath.."exit_normal","ADD")
    frame.ExitButton:SetPoint("TOPRIGHT",-12,-12)  
  --SCRIPTS Buttons
    frame.ExitButton:SetScript("OnEnter",function(self) me:ShowTip(self, "Hide this window") end)
	frame.ExitButton:SetScript("OnLeave",function(self) me:ShowTip() end)
	frame.ExitButton:SetScript("OnClick",function(self) self:GetParent():Hide() end)
--ReportSizeStrip
    frame.Num={}
  for i=1,25 do
    frame.Num[i]=CreateFrame("Frame","rs_ReportWindowNum"..i,frame)
	frame.Num[i]:SetSize(5,20)
	frame.Num[i]:SetID(i)
	if i==1 then frame.Num[i]:SetPoint("TOPLEFT",24,-33) else frame.Num[i]:SetPoint("TOPLEFT",frame.Num[i-1],"TOPRIGHT",0,0) end
	frame.Num[i].Background=frame.Num[i]:CreateTexture(nil,"BACKGROUND")
	  frame.Num[i].Background:SetPoint("TOPLEFT",0,0)
	  frame.Num[i].Background:SetPoint("BOTTOMRIGHT",-1,0)
	  frame.Num[i].Background:SetColorTexture(1,1,1,0.15)
	frame.Num[i].On=frame.Num[i]:CreateTexture(nil,"ARTWORK")
	  frame.Num[i].On:SetPoint("TOPLEFT",0,0)
	  frame.Num[i].On:SetPoint("BOTTOMRIGHT",-1,0)
	  frame.Num[i].On:SetColorTexture(1,1,1,0.5)
	frame.Num[i].Highlight=frame.Num[i]:CreateTexture(nil,"HIGHLIGHT")
	  frame.Num[i].Highlight:SetColorTexture(0,0.25,1,0.25)
	frame.Num[i]:SetScript("OnMouseDown",function(self) me:SetReportSize(self:GetID()); me.ReportWindow.ButtonDown=1 end)
	frame.Num[i]:SetScript("OnMouseUp",function() me.ReportWindow.ButtonDown=nil end)
	frame.Num[i]:SetScript("OnEnter",function(self) if me.ReportWindow.ButtonDown then me:SetReportSize(self:GetID()) end end)
  end--do
--Buttons
  local button
  for i=1,#repWinButtons do
    button=repWinButtons[i]
    frame[button]=CreateFrame("Button","rs_ReportWindow"..button,frame,"rs_ReportButtonTemplate")
	if i==1 then frame[button]:SetPoint("TOP",0,-70) elseif i==8 then frame[button]:SetPoint("TOP",frame[repWinButtons[i-1]],"BOTTOM",0,-34) else frame[button]:SetPoint("TOP",frame[repWinButtons[i-1]],"BOTTOM",0,-4) end
    Recount:AddFontString(frame[button].Text)
  end--do
            me.ReportWindow.SayButton:SetScript("OnClick", function() me:InitiateReport(me.ReportWindow.target, rs_saved["ReportSize"], "SAY") end)
          me.ReportWindow.PartyButton:SetScript("OnClick", function() me:InitiateReport(me.ReportWindow.target, rs_saved["ReportSize"], "PARTY") end)
       me.ReportWindow.InstanceButton:SetScript("OnClick", function() me:InitiateReport(me.ReportWindow.target, rs_saved["ReportSize"], "INSTANCE_CHAT") end)
           me.ReportWindow.RaidButton:SetScript("OnClick", function() me:InitiateReport(me.ReportWindow.target, rs_saved["ReportSize"], "RAID") end)
          me.ReportWindow.GuildButton:SetScript("OnClick", function() me:InitiateReport(me.ReportWindow.target, rs_saved["ReportSize"], "GUILD") end)
        me.ReportWindow.OfficerButton:SetScript("OnClick", function() me:InitiateReport(me.ReportWindow.target, rs_saved["ReportSize"], "OFFICER") end)
         me.ReportWindow.RealIDButton:SetScript("OnClick", function() me:InitiateReport(me.ReportWindow.target, rs_saved["ReportSize"], "REALID") end)
        me.ReportWindow.WhisperButton:SetScript("OnClick", function() me:InitiateReport(me.ReportWindow.target, rs_saved["ReportSize"], "WHISPER", me.ReportWindow.EditBox:GetText()) end)
  me.ReportWindow.WhisperTargetButton:SetScript("OnClick", function() me:InitiateReport(me.ReportWindow.target, rs_saved["ReportSize"], "WHISPER", UnitName("target")) end)
  me.ReportWindow.OfficerButton:SetParent(me.ReportWindow.GuildButton)
  for i=1,#repWinSmallButtons do
    button=repWinSmallButtons[i]
    frame[button]=CreateFrame("Button","rs_ReportWindow"..button,frame,"rs_SmallReportButtonTemplate")
	frame[button]:SetPoint("TOPLEFT",frame.WhisperTargetButton,"BOTTOMLEFT",(i-1)*31,-4)
	Recount:AddFontString(frame[button].Text)
	frame[button]:SetScript("OnClick",function(self) me:InitiateReport(me.ReportWindow.target, rs_saved["ReportSize"], "CHANNEL", self:GetID()) end)
  end--do
    frame.CheckButton=CreateFrame("CheckButton","rs_ReportWindowCheckButton",frame,"rs_ReportCheckButtonTemplate")
	frame.CheckButton:SetPoint("TOPLEFT",frame.Channel1Button,"BOTTOMLEFT",-4,-8)
	frame.CheckButton.Text:SetText("Disable autohide")
    frame.EditBox=CreateFrame("EditBox","rs_ReportWindowEditBox",frame,"rs_ReportEditBoxTemplate")
	frame.EditBox:SetPoint("BOTTOM",frame.WhisperButton,"TOP",0,0)
  --SCRIPTS
    frame:RegisterEvent("PLAYER_TARGET_CHANGED")
	frame.elapsed=0
	frame.update=5
	  me.ReportWindow.SayButton.NormalTexture:SetVertexColor(0.8,0.8,0.8,1)
	  me.ReportWindow.SayButton.Text:SetText("Say")
	  me.ReportWindow.PartyButton.NormalTexture:SetVertexColor(170/255, 167/255, 255/255)
	  me.ReportWindow.PartyButton.Text:SetText("Party")
	  me.ReportWindow.InstanceButton.NormalTexture:SetVertexColor(255/255, 125/255, 0)
	  me.ReportWindow.InstanceButton.Text:SetText("Instance")
	  me.ReportWindow.RaidButton.NormalTexture:SetVertexColor(255/255, 125/255, 0)
	  me.ReportWindow.RaidButton.Text:SetText("Raid")
	  me.ReportWindow.GuildButton.NormalTexture:SetVertexColor(64/255, 251/255, 64/255)
	  me.ReportWindow.GuildButton.Text:SetText("Guild")
	  me.ReportWindow.OfficerButton.NormalTexture:SetVertexColor(64/255, 189/255, 64/255)
	  me.ReportWindow.OfficerButton.Text:SetText("Officer")
	  me.ReportWindow.RealIDButton.NormalTexture:SetVertexColor(0, 251/255, 246/255)
	  me.ReportWindow.RealIDButton.Text:SetText("Real ID")
	  me.ReportWindow.WhisperButton.NormalTexture:SetVertexColor(255/255, 126/255, 255/255)
	  me.ReportWindow.WhisperButton.Text:SetText("Whisper...")
	  me.ReportWindow.WhisperTargetButton.NormalTexture:SetVertexColor(255/255, 126/255, 255/255)
	  me.ReportWindow.WhisperTargetButton.Text:SetText("Whisper Target")
	for i=1,4 do
	    frame["Channel"..i.."Button"].Text:SetText(i)
		frame["Channel"..i.."Button"].NormalTexture:SetVertexColor(255/255,189/255,192/255)
	end
	frame:SetScript("OnEvent", function() if UnitExists("target") and UnitIsPlayer("target") and UnitFactionGroup("target")==UnitFactionGroup("player") then me.ReportWindow.WhisperTargetButton:SetEnabled(true) else me.ReportWindow.WhisperTargetButton:SetEnabled(false) end end)
    frame:SetScript("OnUpdate", function(self,elapsed) self.elapsed=self.elapsed+elapsed; if self.update>self.elapsed then return end
	  if strsub(GetMouseFocus():GetName() or "",1,strlen(self:GetName()))==self:GetName() or rs_saved["DisableAutoHideReport"] then self.elapsed=3 else self:Hide(); self.elapsed=0 end
	end)
	frame:SetScript("OnShow", function(self)
	  local height=386
	  --24
	  local _,_,guildRankIndex = GetGuildInfo("player") 
	  GuildControlSetRank(guildRankIndex)
	  local _,_,_,officerchat_speak=GuildControlGetRankFlags()
	  --if IsInGuild() and (officerchat_speak==1 or (guildRankIndex==0)) then rs_ReportWindowOfficerButton:SetScale(1) else rs_ReportWindowOfficerButton:SetScale(0.0001); height=height-24 end
	  --don't seeme to work atm..
	  if GetNumGroupMembers(LE_PARTY_CATEGORY_HOME) > 0 then me.ReportWindow.PartyButton:SetScale(1) else me.ReportWindow.PartyButton:SetScale(0.0001); height=height-24 end
	  if GetNumGroupMembers(LE_PARTY_CATEGORY_INSTANCE) ~= 0 then me.ReportWindow.InstanceButton:SetScale(1) else me.ReportWindow.InstanceButton:SetScale(0.0001); height=height-24 end
	  if UnitInRaid("player") then me.ReportWindow.RaidButton:SetScale(1) else me.ReportWindow.RaidButton:SetScale(0.0001); height=height-24 end
	  if IsInGuild() then me.ReportWindow.GuildButton:SetScale(1) else me.ReportWindow.GuildButton:SetScale(0.0001); height=height-24-24 end
	  
	  if UnitExists("target") and UnitIsPlayer("target") and UnitFactionGroup("target")==UnitFactionGroup("player") then me.ReportWindow.WhisperTargetButton:SetEnabled(true) else me.ReportWindow.WhisperTargetButton:SetEnabled(false) end

	  me.ReportWindow:SetHeight(height)

	  for chatN =1,10 do
	    if _G["ChatFrame"..chatN] then
			local cList={GetChatWindowChannels(chatN)}
			for i =1, (#cList)/2 do
			  local cNum=tonumber(cList[i*2])
			  if cNum==3 then cNum=100 end
			  if cNum==22 then cNum=3 end
			  if cNum==26 then cNum=4 end
			  if channels[cNum] then channels[cNum]=1 end
	        end--do
		end--if
	  end--do
	  
	  for i=1,4 do
	    if channels[i]==1 then me.ReportWindow["Channel"..i.."Button"]:SetEnabled(true) else me.ReportWindow["Channel"..i.."Button"]:SetEnabled(false) end
	  end
	  
	  if self.target=="Main" then
	    self:SetPoint("TOPRIGHT", Recount.MainWindow.ReportButton,"TOPLEFT",0,50)
	  else
	    --print(self.target)
	    self:SetPoint("TOPRIGHT", me.Windows[self.target].ReportButton,"TOPLEFT",0,50)
	  end
	  me:SetReportSize(rs_saved["ReportSize"] or 3)
	end)
end--me:CreateReportWindow()

function me:updateRecountMergedTextures(self, elapsed)
  if self.elapsed<self.update then self.elapsed=self.elapsed+elapsed; return else self.elapsed=0 end
  --print(Recount.MainWindow.CurRows.." "..#Recount.MainWindow.Rows)
  local ModeIndex=Recount.db.profile.MainWindowMode
  local ModeNameEnglish = me.MainWindowData[ModeIndex][1]
  
  if #Recount.MainWindow.Rows > MERGED_TEXTURES_CREATED then me:UpdateRecountConfigRelated() end
  
  if (ModeNameEnglish=="Damage Done" and Recount.db.profile.MergePets) or (ModeNameEnglish=="Healing Done" and Recount.db.profile.MergeAbsorbs) then
    local offset = FauxScrollFrame_GetOffset(Recount.MainWindow.ScrollBar)
	
    for i=1,Recount.MainWindow.CurRows do
	  if not Recount.MainWindow.Rows[i]:IsVisible() then break end
	  local merged,full=me:ReturnMergedAmount(ModeNameEnglish,Recount.MainWindow.Rows[i].name)
	  Recount.MainWindow.Rows[i].Merged=merged
	  Recount.MainWindow.Rows[i].Value=full
	  local percent = merged / full
	  local minV,maxV=Recount.MainWindow.Rows[i].StatusBar:GetMinMaxValues()
	  local val=Recount.MainWindow.Rows[i].StatusBar:GetValue()
	  local barW=Recount.MainWindow.Rows[i]:GetWidth()*(val/maxV)
	  if not rs_saved["usemergedoverlay"] then
		Recount.MainWindow.Rows[i].StatusBar.MergedTexture:SetWidth((barW*percent)+0.000001)
	  else
	    Recount.MainWindow.Rows[i].StatusBar.MergedTexture:SetWidth(0.000001)
	  end
    end
  else
    for i=1,Recount.MainWindow.CurRows do
      Recount.MainWindow.Rows[i].StatusBar.MergedTexture:SetWidth(0.000001)
    end
  end
  
  
end--function

-- Create Frames
-- XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
-- Skin Recount
function me:UpdateCursorProximity(frame,point,relativeTo,relativePoint,x,y,maxScaleAt,minScaleAt)
  local scale,distance,curX,curY,cenX,cenY,w,h
  
  curX,curY=GetCursorPosition()
  cenX,cenY=frame:GetCenter()
  cenX=cenX*frame:GetEffectiveScale()
  cenY=cenY*frame:GetEffectiveScale()
  
  w,h=cenX-curX, cenY-curY
  distance=sqrt((w*w)+(h*h))
  if me.Config:IsShown() then
    scale=1
  elseif rs_SelectModeWindow:IsShown() then
    scale=0.000001
  else
    if distance>=minScaleAt then
      scale=0.000001
    elseif distance<=maxScaleAt then
      scale=1
    else
     scale=1-((distance-maxScaleAt)/minScaleAt)
   end
  end
  --print("curX:"..curX.." curY:"..curY.." cenX:"..cenX.." cenY:"..cenY.." Dist:"..distance)
  
  frame:SetPoint(point, relativeTo, relativePoint, x, y/scale)
  frame:SetScale(scale)
  Recount.MainWindow.Title:SetPoint("LEFT",me.ToggleButton,"RIGHT",6-(4*scale),0)
end--function

function me:RecountSkinByNth()
  print("|cffffcc00Recount|rSkinByNth:"..me.MadeForVersion.." | Current Recount:"..Recount.Version) --Announce in Chatframe that Skin  is beeing applyed
  IS_RECOUNT_SKINNED=1
  --MainWindow
    me:RemoveAllTexturesFromFrame(Recount.MainWindow)
	CreateFrame("Frame","Recount_MainWindow_Background",Recount.MainWindow)
	Recount_MainWindow_Background:SetPoint("TOPLEFT",-12,0)
	Recount_MainWindow_Background:SetPoint("BOTTOMRIGHT",12,-12)
	Recount_MainWindow_Background:SetFrameLevel(Recount.MainWindow:GetFrameLevel()-1)
	me:FixFrameBackdrop(Recount_MainWindow_Background)
	me:FixVerticalScrollBar(Recount_MainWindow_ScrollBarScrollBar,"noBg")
	RecountResizeGripLeft:ClearAllPoints()
	RecountResizeGripLeft:SetPoint("BOTTOMLEFT",-7,-7)
	RecountResizeGripRight:ClearAllPoints()
	RecountResizeGripRight:SetPoint("BOTTOMRIGHT",7,-7)
  --TitleLine
    me.RecountTitleBar=Recount.MainWindow:CreateTexture(nil,"ARTWORK")
	me.RecountTitleBar:SetPoint("TOPLEFT",-4,-10)
	me.RecountTitleBar:SetPoint("RIGHT",4,0)
	me.RecountTitleBar:SetHeight(22)
	me.RecountTitleBar:SetColorTexture(1,1,1)
	
  --Toggle Button
    me.ToggleButton=CreateFrame("Button","Recount_MainWindow_Secondary",Recount.MainWindow)
	--me.ToggleButton.maxScaleAt=50	--Screen Units
	--me.ToggleButton.minScaleAt=150	--Screen Units
	me.ToggleButton:SetSize(16,16)
 	me.ToggleButton:SetPoint("LEFT",Recount.MainWindow,"TOPLEFT",0,-20)
	me.ToggleButton:SetNormalTexture("Interface\\Addons\\RecountSkinByNth\\textures\\openwindow_normal")
	me.ToggleButton:SetHighlightTexture("Interface\\Addons\\RecountSkinByNth\\textures\\openwindow_normal")
	me.ToggleButton:SetScript("OnEnter", function(self) me:ShowTip(self, "Toggles secondary window\n|cffffbb00Shift|r|cff999999 Opens another window\n|r|cffffbb00CTRL|r|cff999999 Toggles Skin settings|r",1) end)
	me.ToggleButton:SetScript("OnLeave", function() me:ShowTip() end)
	me.ToggleButton:SetScript("OnClick",function()
	  if IsControlKeyDown() then
	    if me.Config:IsShown() then me.Config:Hide() else me.Config:Show() end
	  elseif IsShiftKeyDown() then
	    me:NewWindow()
	    --rs_SlashCommands("new")
	  else
	    if me.Windows[1]:IsShown() then me.Windows[1]:Hide(); rs_saved["Shown"][1]=nil else me.Windows[1]:Show(); rs_saved["Shown"][1]=1 end
	  end
	end)--SetScript
	me.ToggleButton.update=1/10
	me.ToggleButton.elapsed=0
	me.ToggleButton:SetScript("OnUpdate", function(self,elapsed) me:UpdateCursorProximity(self,"LEFT",Recount.MainWindow,"TOPLEFT",0,-20,10,25); me:updateRecountMergedTextures(self,elapsed) end)--SetScript
  --Buttons
    Recount.MainWindow.Title:ClearAllPoints()
	Recount.MainWindow.Title:SetPoint("LEFT",me.ToggleButton,"RIGHT",0,0)
	me:ChangeRecountControlTextures(Recount.MainWindow.CloseButton,"exit")
	me:ChangeRecountControlTextures(Recount.MainWindow.RightButton,"next")
	me:ChangeRecountControlTextures(Recount.MainWindow.LeftButton,"previous")
	me:ChangeRecountControlTextures(Recount.MainWindow.ResetButton,"reset")
	me:ChangeRecountControlTextures(Recount.MainWindow.FileButton,"data")
	me:ChangeRecountControlTextures(Recount.MainWindow.ConfigButton,"config")
	me:ChangeRecountControlTextures(Recount.MainWindow.ReportButton,"report")
	Recount.MainWindow.TitleClick:SetScript("OnEnter", function(self) me:ShowTip(self, "Select statistic | Move") end)
    Recount.MainWindow.TitleClick:SetScript("OnLeave", function(self) me:ShowTip() end)	
	Recount.MainWindow.CloseButton:SetScript("OnEnter", function(self) me:ShowTip(self, "Hide Recount Window") end)
	Recount.MainWindow.RightButton:SetScript("OnEnter", function(self) me:ShowTip(self, "Show next stat") end)
	Recount.MainWindow.LeftButton:SetScript("OnEnter", function(self) me:ShowTip(self, "Show previous stat") end)
	Recount.MainWindow.ResetButton:SetScript("OnEnter", function(self) me:ShowTip(self, "Erase data") end)
	Recount.MainWindow.ResetButton:SetScript("OnClick", function() if Recount.ResetFrame:IsShown() then Recount.ResetFrame:Hide() else Recount:ShowReset() end end)
	Recount.MainWindow.FileButton:SetScript("OnEnter", function(self) me:ShowTip(self, "Select data") end)
	Recount.MainWindow.ConfigButton:SetScript("OnEnter", function(self) me:ShowTip(self, "Open configuration Window") end)
	Recount.MainWindow.ReportButton:SetScript("OnEnter", function(self) me:ShowTip(self, "Initiate report") end)
    Recount.MainWindow.ReportButton:SetScript("OnClick", function() me:ReportFuntion("Main") end)
	Recount.MainWindow.TitleClick:SetScript("OnMouseDown", function(self,button)
	    if button=="RightButton" then
		  if rs_SelectModeWindow:IsVisible() then rs_SelectModeWindow:Hide() else rs_SelectModeWindow.target="Main"; rs_SelectModeWindow:Show() end
		else
		  local x,y=GetCursorPosition()
		  self.x=floor(x); self.y=floor(y)
	      Recount.MainWindow:StartMoving()
	    end
	  end)
	Recount.MainWindow.TitleClick:SetScript("OnMouseUp", function(self)
	      Recount.MainWindow:StopMovingOrSizing()
		  local x,y=GetCursorPosition()
		  if self.x==floor(x) and self.y==floor(y) then
		    if me.SelectModeWindow:IsVisible() then me.SelectModeWindow:Hide() else me.SelectModeWindow.target="Main"; me.SelectModeWindow:Show() end
		  end
		  self.x=0; self.y=0
	  end)
    Recount.MainWindow.FileButton:SetScript("OnClick", function(self) me.FightsPopup:SetPoint("RIGHT",self,"LEFT",3,0); if me.FightsPopup:IsShown() then me.FightsPopup:Hide() else me.FightsPopup:Show() end end)	  
--ConfigWindow
    me:RemoveAllTexturesFromFrame(Recount.ConfigWindow)
	Recount.ConfigWindow.Background=CreateFrame("Frame","Recount_ConfigWindow_Background",Recount.ConfigWindow)
	Recount.ConfigWindow.Background:SetPoint("TOPLEFT",-12,0)
	Recount.ConfigWindow.Background:SetPoint("BOTTOMRIGHT",12,-12)
	Recount.ConfigWindow.Background:SetFrameLevel(Recount.ConfigWindow:GetFrameLevel()-1)
	me:FixFrameBackdrop(Recount.ConfigWindow.Background)
	me:ChangeRecountControlTextures(Recount.ConfigWindow.CloseButton,"exit")
	Recount.ConfigWindow.CloseButton:SetSize(16,16)
    Recount.ConfigWindow.CloseButton:SetScript("OnEnter", function(self,texture) me:ShowTip(self, "Hide Config Window") end)
	--TitleBar
    Recount.ConfigWindow.TitleBar=Recount.ConfigWindow:CreateTexture(nil,"ARTWORK")
	Recount.ConfigWindow.TitleBar:SetPoint("TOPLEFT",-4,-10)
	Recount.ConfigWindow.TitleBar:SetPoint("RIGHT",4,0)
	Recount.ConfigWindow.TitleBar:SetHeight(22)
	Recount.ConfigWindow.TitleBar:SetColorTexture(1,1,1)
    Recount.ConfigWindow.TitleBar:SetGradientAlpha("VERTICAL",0.25,0.25,0.25,1,0.25,0.25,0.25,0)
--DetailWindow
    me:RemoveAllTexturesFromFrame(Recount.DetailWindow)
	CreateFrame("Frame","Recount_DetailWindow_Background",Recount.DetailWindow)
	Recount_DetailWindow_Background:SetPoint("TOPLEFT",-12,0)
	Recount_DetailWindow_Background:SetPoint("BOTTOMRIGHT",12,-12)
	Recount_DetailWindow_Background:SetFrameLevel(Recount.DetailWindow:GetFrameLevel()-1)
	me:FixFrameBackdrop(Recount_DetailWindow_Background)
	me:FixVerticalScrollBar(Recount_PieMode_Scrollbar2ScrollBar,"noBg")
	me:ChangeRecountControlTextures(Recount.DetailWindow.CloseButton,"exit")
	me:ChangeRecountControlTextures(Recount.DetailWindow.RightButton,"next")
	me:ChangeRecountControlTextures(Recount.DetailWindow.LeftButton,"previous")
	me:ChangeRecountControlTextures(Recount.DetailWindow.ReportButton,"report")
	me:ChangeRecountControlTextures(Recount.DetailWindow.SummaryButton,"search")
	Recount.DetailWindow.CloseButton:SetSize(16,16)
	Recount.DetailWindow.RightButton:SetSize(16,16)
	Recount.DetailWindow.LeftButton:SetSize(16,16)
	Recount.DetailWindow.ReportButton:SetSize(16,16)
	Recount.DetailWindow.SummaryButton:SetSize(16,16)
	Recount.DetailWindow.CloseButton:SetScript("OnEnter", function(self) me:ShowTip(self, "Hide Details Window") end)
	Recount.DetailWindow.RightButton:SetScript("OnEnter", function(self) me:ShowTip(self, "Next") end)
	Recount.DetailWindow.LeftButton:SetScript("OnEnter", function(self) me:ShowTip(self, "Previous") end)
	Recount.DetailWindow.ReportButton:SetScript("OnEnter", function(self) me:ShowTip(self, "Open report tool") end)
	Recount.DetailWindow.SummaryButton:SetScript("OnEnter", function(self) me:ShowTip(self, "Summary | Details") end)
--Reset Window
  --Skinned on Demand when the window is created
	Recount:ShowReset()			--Force load the resetframe
	me:FindResetWindow()		--Search UParent children frames for criteria and assign a key for the frame. must be 200x78 and have .Title key
	Recount.ResetFrame:Hide()	--Hide and Skin it :-) voila!
  me:RemoveAllTexturesFromFrame(Recount.ResetFrame)
	Recount.ResetFrame.Background = CreateFrame("Frame","Recount_ResetWindow_Background",Recount.ResetFrame)
	Recount.ResetFrame.Background:SetPoint("TOPLEFT",-12,0)
	Recount.ResetFrame.Background:SetPoint("BOTTOMRIGHT",12,-12)
	Recount.ResetFrame.Background:SetFrameLevel(Recount.ResetFrame:GetFrameLevel()-1)
	me:FixFrameBackdrop(Recount.ResetFrame.Background)
	Recount.ResetFrame.TitleBar=Recount.ResetFrame:CreateTexture(nil,"ARTWORK")
	Recount.ResetFrame.TitleBar:SetPoint("TOPLEFT",-4,-10)
	Recount.ResetFrame.TitleBar:SetPoint("RIGHT",4,0)
	Recount.ResetFrame.TitleBar:SetHeight(22)
	Recount.ResetFrame.TitleBar:SetColorTexture(1,1,1)
	--local C=Recount.db.profile.Colors["Other Windows"].Title
    --local r,g,b,a=C.r,C.g,C.b,C.a
	--Recount.ResetFrame.TitleBar:SetGradientAlpha("VERTICAL",r,g,b,a,r,g,b,0)
--Buttons
    Recount.ResetFrame.ExitButton=CreateFrame("Button",nil,Recount.ResetFrame)
    Recount.ResetFrame.ExitButton:SetSize(16,16)
	Recount.ResetFrame.ExitButton:SetNormalTexture(me.texPath.."exit_normal")
	Recount.ResetFrame.ExitButton:SetHighlightTexture(me.texPath.."exit_normal","ADD")
	Recount.ResetFrame.ExitButton:SetPoint("TOPRIGHT",-4,-12)
  --SCRIPTS Buttons
    Recount.ResetFrame.ExitButton:SetScript("OnEnter",function(self) me:ShowTip(self, "Cancel Reset") end)
	Recount.ResetFrame.ExitButton:SetScript("OnLeave",function(self) me:ShowTip() end)
	Recount.ResetFrame.ExitButton:SetScript("OnClick",function(self) self:GetParent():Hide() end)
--Adjust width to fit text if neccisary, ! french one goes outside the frame and looks bad
  local fnt,size,flags=Recount.ResetFrame.Text:GetFont()
  Recount.ResetFrame.Text:SetFont(fnt,14,flags)		--Increase text size slightly
  Recount.ResetFrame:SetHeight(88)
  if Recount.ResetFrame.Text:GetStringWidth()>Recount.ResetFrame:GetWidth()-20 then Recount.ResetFrame:SetWidth(Recount.ResetFrame.Text:GetStringWidth()+20) end
  me:FixButtonTextures(Recount.ResetFrame.YesButton, 0.5,0,0)
  me:FixButtonTextures(Recount.ResetFrame.NoButton, 0.5,0,0)

	
end--function


function me:FindResetWindow()
  local ItemChild = { UIParent:GetChildren() };
  for i, child in ipairs(ItemChild) do
    if i>249 then
      if floor(child:GetWidth()+0.5)==200 and floor(child:GetHeight()+0.5)==78 and child.Title and child.Text and child.YesButton and child.NoButton then
        --print(i.." <--")
        Recount.ResetFrame=child
      end--if
    end--if
  end--do
end--

function me:FixRecountConfigStuff()

end--

--// CONFIRM THIS ROUTINE WHEN ReCOUNT UPDATES

	function me:SetRecountFightData(FightMode, FightName)
		Recount.db.profile.CurDataSet = FightMode
	  --Recount:MainWindowNextMode()  --// used to provoke a closed recount subroutine
	  --Recount:MainWindowPrevMode()  --// appears to be redundant
		Recount.MainWindow.DispTableSorted = {}
		Recount.MainWindow.DispTableLookup = {}
		Recount.FightName = FightName
		Recount:RefreshMainWindow()
		if RecountDeathTrack then RecountDeathTrack:SetFight(Recount.db.profile.CurDataSet) end
		me.FightsPopup:Hide()
		me:UpdateRecountConfigRelated()
	end--function me:SetRecountFightData()

--// CONFIRM THIS ROUTINE WHEN ReCOUNT UPDATES

--EOF